// C Source File
// Created 2/3/2013; 9:46:48 AM

#include <tigcclib.h>
#include "defines.h"
#include "new_worlds.h"

///////////////////////////////////////////////////////////////////////////////////////////////////////////////
//
//										remember, you can only modify these files in this routine
//
///////////////////////////////////////////////////////////////////////////////////////////////////////////////
//#define create_warp_same_map(loc, mapx, mapy, x_sprite, y_sprite, return_dir, to_mapx, to_mapy, to_x_sprite, to_y_sprite, return_start_dir)  create_warp_point_set(loc, mapx, mapy, x_sprite, y_sprite, return_dir, same_map, 0, same_map, 0, to_mapx, to_mapy, to_x_sprite, to_y_sprite, return_start_dir)





///////////////////////////////////////////////////////////////////////////////////////////////////////////////
/*
							set_warps():
							use set_warp_point() or create_warp_point_set() in order to create a set of warp points.
							this just calls those functions, instead of manually modifing an array to hold all the warping
							info.  this makes things easer to manage, create, and modify.
							- you can only have a max of 11 spots at this point and time. - this can be changed in the 
							defines.h file. 	search for #define warp_points.  remember that the define file is attached to
							the zelda and ezelda files, so if you change this define then it will auto change everything to
							work correctly, so no code changes are necessary - only a recompile is.
							- the switch() statement is used for the file id# you want to use.  
							- example: if you call: create_warp_file(2), then "case 2:" in set_warps() will be called.  this will execute each
							set_warp_point() inside of it, therefore filling the warp point array with warp points.  then the 
							array will be saved.
							- only modify the switch statement.  dont modify anything else.		
							- at the end of each case statment, you will need to add "create=TRUE;" if you want to have the 
									warp file created. - this will allow you to call create_warp_file() in a loop to auto create all warp files
									for you.

							syntax for the set_warp_point:
							
			void set_warp_point(int loc, int mapx, int mapy, int x_sprite, int y_sprite, int to_ow,	int to_map, 
													int to_map_x, int to_map_y, int to_sprite_x, int to_sprite_y)

			create_warp_point_set(loc, mapx, mapy, x_sprite, y_sprite, return_dir, return_ow, return_map, to_ow, 
														to_map, to_map_x, to_map_y, to_sprite_x, to_sprite_y, return_start_dir)
								
								- create_warp_point_set() creates 2 warp points - one to room "A" and then a return warp from
										room "A" back to room "B".  this is usually used for stairs, or a place where there is an
										entrance and exit from the same place.


*/
///////////////////////////////////////////////////////////////////////////////////////////////////////////////

void create_warp_same_map(int loc, int mapx,int mapy, int x_sprite, int y_sprite, int return_dir, 
													int	to_mapx, int to_mapy, int to_x_sprite, int to_y_sprite, int return_start_dir)
{
	create_warp_point_set(loc, mapx, mapy, x_sprite, y_sprite, return_dir, same_map, same_map, same_map, same_map, to_mapx, to_mapy, to_x_sprite, to_y_sprite, return_start_dir);
}// end create warp point


int set_warps(int i)
{
//*** a warning though: do not add the same_map warps of different maps to the same warp file.  this will cause
//		a strange dissaster.   

// you can only have a max of 12 warp points or a max of 6 warp point sets
int create=FALSE;
	switch (i)
	{

		case 1:
				create_warp_same_map(1, 2, 4, 5, 4, left, 0, 7, 7, 6, right);
				//make one for the entrance
				// make completion warp
				create=TRUE;
		break;
		case 2:
				create_warp_same_map(1, 7, 3, 8, 4, left, 0, 3, 4, 3, left);// a
				create_warp_same_map(2, 1, 3, 8, 4, left, 2, 4, 4, 3, left);//b
				create_warp_same_map(3, 1, 4, 8, 4, left, 0, 7, 2, 6, left);//c
				// make entree warp
				// make completion warp
				create=TRUE;
		break;
		case 3:// no warping in level 3
		break;
		case 4:// level 4 
			//	create_warp_same_map(1, 7, 4, 5, 7, up, 2, 200, 1, 4, 0, 4, 9, 6, up);// room #5
				create_warp_same_map(2, 4, 1, 1, 1, right, 0, 0, 2, 6, left);
				create_warp_same_map(3, 1, 6, 8, 1, left, 7, 7, 7, 6, right);
				create=TRUE;
		break;
		case 5:// level 5 
				create_warp_same_map(1, 7, 1, 8, 1, left, 3, 3, 7, 1, right);// a
				create_warp_same_map(2, 7, 5, 8, 1, left, 1, 3, 6, 3, left);// b
				create_warp_same_map(3, 2, 7, 8, 1, left, 5, 4, 7, 1, right);// c
				create_warp_same_map(4, 5, 5, 8, 1, left, 1, 7, 7, 4, right);// d
				create_warp_same_map(5, 2, 3, 8, 1, left, 0, 2, 7, 6, right);// to item?
				create_warp_same_map(6, 4, 3, 8, 1, left, 1, 1, 7, 6, right);// to boss key
				create=TRUE;
				// make entree warp
				// make completion warp
		break;
		case 6: // level 6
				create_warp_same_map(1, 0, 5, 8, 1, left, 2, 1, 4, 3, left);//a
				create_warp_same_map(2, 1, 2, 5, 4, left, 4, 5, 2, 6, left);// candle
				create=TRUE;
				// make entree warp
				// make completion warp
		break;
		case 7:// level 7 
		//		create_warp_same_map(1, 6, 2, 4, 0, down, 1, 4, 2, 202, 7, 2, 4, 6, down);// rom #37
				create_warp_same_map(2, 4, 3, 8, 6, left, 0, 6, 2, 1, left);
				create_warp_same_map(3, 2, 5, 8, 1, left, 6, 0, 7, 6, right);
			//	create_warp_same_map(4, 5, 3, 6, 1, down, 1, 4, 3, 206, 7, 5, 7, 4, up);// links to dungeon 206			
				create=TRUE;
		break;		
		case 8:// level 8
				create_warp_same_map(1, 7, 3, 1, 6, right, 3, 5, 7, 1, right);// c
				create_warp_same_map(2, 5, 7, 8, 1, left, 0, 6, 7, 1, right);// b
				create_warp_same_map(3, 1, 5, 8, 1, left, 0, 1, 7, 1, right);// a
				create_warp_same_map(4, 0, 0, 8, 1, left, 0, 3, 2, 6, left);// key
				create_warp_same_map(5, 0, 4, 8, 6, left, 4, 5, 7, 1, right);// bottle
				// make entree warp
				// make completion warp
				create=TRUE;
		break;
		case 9:// level 9 part 1
				create_warp_same_map(1, 7, 4, 5, 3, right, 7, 1, 7, 4, right);// c
				create_warp_same_map(2, 6, 1, 3, 3, down, 2, 0, 3, 3, right);// d
				create_warp_same_map(3, 6, 3, 8, 4, left, 0, 5, 7, 1, right);// b
				create_warp_same_map(4, 5, 5, 8, 1, left, 1, 4, 4, 3, left);// a 
				create_warp_same_map(5, 3, 0, 3, 3, left, 0, 4, 6, 3, left);// e
				create_warp_same_map(6, 0, 3, 5, 3, left, 5, 2, 7, 4, right);// f
				create=TRUE;
		break; 
		case 10:// level 9 part 2
				create_warp_same_map(1, 0, 0, 8, 6, left, 0, 7, 6, 3, left);// tunic
				create=TRUE;
				// make entree warp
		break;
		case 11:// these are all the completion warps for dungeon 1 to 8
			set_warp_point(1, 3, 0, 1, 1, 1, 4, 10, 7, 0, 4, 5);// level 1 out
			set_warp_point(2, 0, 2, 2, 1, 1, 4, 10, 7, 6, 4, 4);// level 2 out
			set_warp_point(3, 0, 4, 3, 1, 1, 4, 10, 3, 0, 3, 5);// level 3 out
			
			set_warp_point(4, 5, 7, 4, 1, 1, 4, 11, 6, 5, 5, 3);// level 4 out
			set_warp_point(5, 1, 4, 5, 1, 1, 4, 11, 0, 4, 5, 5);// level 5 out
			set_warp_point(6, 2, 3, 6, 1, 1, 4, 11, 4, 0, 5, 6);// level 6 out
			
			set_warp_point(7, 0, 1, 7, 1, 1, 4, 12, 0, 2, 4, 5);// level 7 out
			set_warp_point(8, 0, 7, 8, 1, 1, 4, 12, 1, 6, 2, 3);// level 8 out
			create=TRUE;
										
		break;
		case 12: // these are dungeon entrance warps for dungeon 1 to 6
			create_warp_point_set(1, 7, 0, 4, 4 ,down, 4, 10, 1, 1, 7, 3, 7, 6, right);// level 1 - 30
			create_warp_point_set(2, 7, 6, 4, 3 ,down, 4, 10, 1, 2, 7, 4, 7, 6, right);// level 2 - 31
			// level 3 is in #16 due to issues
			create_warp_point_set(3, 6, 5, 5, 2, down, 4, 11, 1, 4, 7, 4, 7, 6, right);// level 4 - room 200
			create_warp_point_set(4, 0, 4, 5, 4 ,down, 4, 11, 2, 5, 7, 2, 2, 1, left);// level 5 - 33
			create_warp_point_set(5, 4, 0, 5, 5 ,down, 4, 11, 2, 6, 7, 1, 2, 6, left);// level 6 -34
			create=TRUE;		
		break;
		case 13: // these are the dungeon etrance warps for dungeon 7 to 9
		break;
		case 14:// warps for the shops
				create_warp_point_set(1, 5, 1, 5, 6, down, 4, 10, 4, 13, 0, 0, 5, 6, down);// shop 1
				create_warp_point_set(2, 3, 5, 3, 5, down, 4, 10, 4, 13, 0, 2, 5, 6, down);// shop 2
				create_warp_point_set(3, 0, 7, 7, 1, down, 4, 11, 4, 13, 0, 4, 5, 6, down);// shop 3 - forrest
				create_warp_point_set(4, 3, 4, 6, 4, down, 4, 10, 4, 13, 0, 6, 5, 6, down);// heart container
				
				create_warp_point_set(5, 1, 0, 5, 4, down, 4, 12, 4, 13, 2, 0, 5, 6, down);// shop 4 - water area
				create_warp_point_set(6, 0, 0, 8, 5, down, 4, 10, 4, 13, 2, 2, 5, 6, down);// rupie bag
				create=TRUE;
			//	create_warp_point_set(3,   4, 10, 4, 13, 0, 4, 5, 6, down);// shop 3
				//create_warp_point_set(4,   4, 10, 4, 13,   5, 6, down);// shop 4
				
				
		break;
		case 15: // warps for the various houses
		break;
		case 16: // 1-4, 11, level 3 warps for the mountain area p1 - map #10 - ow =4 
				create_warp_same_map(1, 4, 1, 2, 2, down, 3, 2, 5, 6, up);// 1 // 1,3,2 is together
				create_warp_same_map(2, 3, 1, 3, 5, down, 4, 1, 8, 2, up);// 2
				create_warp_same_map(3, 4, 1, 6, 1, down, 4, 0, 6, 1, up);// 3// 3 and 2 are together
				create_warp_same_map(4, 4, 0, 4, 0, down, 3, 0, 7, 6, up);// 4 // 3 and 4 are together
				create_warp_same_map(5, 1, 6, 3, 2, down, 1, 5, 4, 1, up);// 11 
				create_warp_point_set(6, 3, 0, 3, 4 ,down, 4, 10, 1, 3, 7, 5, 7, 6, right);// level 3 - 32
				create=TRUE;
		break;
		case 17: // 5 to 10 warps for the mountain area p2
				create_warp_same_map(1, 4, 7, 3, 3, down, 4, 5, 6, 4, up);// 7
				create_warp_same_map(2, 4, 5, 4, 3, down, 0, 3, 1, 2, up);// 8
				create_warp_same_map(3, 4, 7, 1, 3, down, 4, 7, 4, 7, up);// 9
				create_warp_same_map(4, 4, 2, 8, 2, down, 4, 2, 4, 1, up);// 10
				create_warp_same_map(5, 4, 2, 1, 1, down, 5, 6, 8, 2, up);// 5  // 5 and 6 are together
				create_warp_same_map(6, 5, 6, 6, 1, down, 4, 6, 7, 4, up);// 6	// 5 and 10 are together
				create=TRUE;
				
		break;
		case 18: //12 to forest  warps for the mountain area p3
				create_warp_same_map(1, 0, 5, 4, 3, down, 0, 4, 8, 7, up);// 14
				create_warp_same_map(2, 1, 4, 1, 0, down, 0, 1, 8, 2, up);// 12 // 8 and 12 are together
				create_warp_same_map(3, 0, 2, 2, 1, down, 0, 6, 1, 6, up);// 13
				create_warp_same_map(4, 0, 4, 7, 3, down, 0, 7, 8, 2, up);// 15
				create_warp_same_map(5, 0, 4, 4, 3, down, 1, 3, 3, 1, up);// 17
				create_warp_point_set(6, 0, 7, 7, 4, down, 4, 10, 4, 11, 7, 4, 4, 5, up);// to the forest
				create=TRUE;
		break;
		case 19: // warps for the forest area
				create_warp_point_set(1, 0, 3, 5, 2, right, 4, 11, 3, 14, 0, 0, 7, 1, right);// 2 to world 14
				create_warp_point_set(2, 3, 5, 8, 1, left, 4, 11, 3, 14, 2, 3, 7, 6, right);//2 to warp 3
				create_warp_point_set(3, 2, 5, 3, 5, right, 4, 11, 3, 14, 0, 3, 7, 6, right);//2 to level 4/5
				create_warp_same_map(4, 5, 5, 4, 4, right, 0, 0, 2, 1, left);// 3
				create_warp_same_map(5, 7, 1, 4, 6, right, 4, 5, 4, 5, down);// 1
				create_warp_point_set(6, 3, 1, 7, 5 ,down, 4, 11, 4, 12, 0, 7, 7, 3, up);// forrest to water area
				create=TRUE;
		break;
		case 20:// warps for water area
				create_warp_same_map(1, 7, 7, 8, 6, left, 5, 1, 6, 5, left);// 1
				create_warp_same_map(2, 2, 2, 8, 1, left, 3, 0, 2, 1, left);//4
				create_warp_same_map(3, 3, 7, 8, 4, left, 2, 2, 2, 6, left);// 3
				
				set_warp_point(6, 7, 6, same_map, 6, 6, same_map, same_map, 7, 4, 4, 3);// #2 out
				set_warp_point(7, 2, 2, same_map, 8, 6, same_map, same_map, 7, 4, 4, 3);// same place as warp 3&4
				set_warp_point(8, 0, 3, same_map, 2, 4, same_map, same_map, 7, 4, 4, 3);// level 7 out
				set_warp_point(9, 4, 3, same_map, 3, 1, same_map, same_map, 7, 4, 4, 3);// level 9 out
				set_warp_point(10, 5, 7, same_map, 8, 3, same_map, same_map, 7, 4, 4, 3);// heart container out
				create=TRUE;
		break;
		case 21:// singular warps for water area
				create_warp_point_set(1, 4, 2, 4, 4 ,down, 4, 12, 3, 9, 7, 6, 4, 4, right);// level 9 - 36
				create_warp_point_set(2, 1, 6, 2, 2 ,down, 4, 12, 2, 8, 7, 4, 7, 6, right);// level 8 - 35
				create_warp_same_map(3, 7, 5, 1, 6, right, 1, 6, 7, 6, right);//2 - this is with level 8
				create_warp_point_set(4, 0, 2, 4, 4 ,down, 4, 12, 2, 7, 7, 2, 5, 4, left);// level 7 - 202
				create=TRUE;
		break;
	}// end switch
	return create;
}// end set warps	

	
///////////////////////////////////////////////////////////////////////////////////////////////////////////////
/*
void create_warp_same_map(int loc, int mapx, int mapy, int x_sprite, int y_sprite, int return_dir, int return_ow, int return_map,
										int to_ow, int to_map,int to_map_x, int to_map_y, int to_sprite_x, int to_sprite_y, int return_start_dir)

create_warp_same_map(loc, mapx, mapy, x_sprite, y_sprite, return_dir, to_mapx, to_mapy, to_x_sprite, to_y_sprite, return_start_dir) 

x=up/down
y=l/r

mapx/y=8x8 world map
x/y_sprite =8x10 room map 

define get_mob_stat(who, stat) g_mob_list(who,stat)
*/
///////////////////////////////////////////////////////////////////////////////////////////////////////////////



///////////////////////////////////////////////////////////////////////////////////////////////////////////////
/*


*/
///////////////////////////////////////////////////////////////////////////////////////////////////////////////

