// C Source File
// Created 1/25/2015; 10:45:23 AM

#include <tigcclib.h>
#include "defines.h"
#include "new_mobs.h"
#include "routines.h"
#include "unique.h"

extern int mob_stat1[max_mobs][mob_num_of_stats];
extern int loc_in_pic_arr, mob_location,creature_animation_speed;

void clr_mob_list()
{
	int i=0,k=0;
	while (i<max_mobs){
		while (k<mob_num_of_stats)
		{
			mob_stat1[i][k]=(-100);// used in the game, so do not delete
			k++;
		}// end while k<15
		
		mob_stat1[i][mob_frame]=0;// use as default,  b/c you do not want to start out at -100 in frames
		mob_stat1[i][mob_dir]=0;// prevents problems.
		mob_stat1[i][mob_stunned]=0;
		mob_stat1[i][mob_underground]=0;
		mob_stat1[i][mob_id]=i+15;
		mob_stat1[i][mob_h]=14;// a default where all mobs have the same width and height
		mob_stat1[i][mob_w]=14;
		i++;k=0;
		// the mob simply just does not move if you do.
	}// end while i<64
}// end clr mob list



// defines for speed

/*
#define stopped 0
#define very_slow 66
#define slow_speed 1
#define normal_speed 2
#define fast_speed 3
*/

// defines for toughness and dmg

#define weak 4
#define normal 8
#define strong 12
#define hard 16
#define super 24
#define ultra 32

// defines for weapons

#define no_atk 0

void fill_the_rest()
{
	int i=0;
		
	for (i=mob_location;i<max_mobs;i++){no_mob();}
	
}

/*
			move types:
			
			MOB_WANDER, MOB_FLUTTER, MOB_HOP, MOB_FOLLOW, MOB_BAT, MOB_WIZARD, MOB_SPIKE, MOB_CONSTANT, MOB_GHOST
			
			mob types:
			
			flyer, ghost, digger, chicken, dog, monster, crab, generic, towns_people, wizard, quest_master
			pede_head, pede_body, evil_eye, circle_eye, spider 24		
			***ghost is depreciated, use flyer instead

			generic routines
			
			pre_mob_generic( int toughness, int atk, int dmg, int spd)
			pre_mob_gen_flyer( int toughness, int atk, int dmg, int spd, int mv_type)
			pre_mob_full( int type,  int toughness, int atk, int dmg, int spd, int mv_type, int shld)
			pre_mob_boss( int x, int y, int type,  int toughness, int atk, int defence, int dmg, int spd, int mv_type, int shld ); 
			
			weapons:
			mob_weap_wood_sword, mob_weap_boomerang, mob_weap_arrow, mob_weap_ball, mob_weap_white_sword, 
			mob_weap_fireball, mob_weap_magic, mob_weap_fireball3, mob_weap_fireball5, mob_weap_follow	
		
*/
void create_crystal_mobs(int i)
{
	clr_mob_list();
	clr_mob_arrs();// clear out the gfx
	loc_in_pic_arr=0;
	mob_location=0;// restart the location.
	int create=TRUE, skip=FALSE;
	creature_animation_speed=5;
	switch (i)
	{
		case 1:
		/*
			level 1 has  slime, toadstool
		*/
			pic_slime();
			pre_mob_generic( weak, no_atk, 2, slow_speed);
			pic_shroom();// this is the toadstool
			pre_mob_generic( weak, no_atk, weak, normal_speed);
			pic_knight_dark();// boss
			pre_mob_full( generic, 20 , no_atk, normal, normal_speed, MOB_WANDER, shield_equipped, sometimes);
			create=TRUE;
		break;
		case 2:
			/*
			level 2 has  flying imp, super slime, snake
			*/
			pic_flying_imp();
			pre_mob_full( flyer, normal , no_atk, weak, normal_speed, MOB_WANDER, immune_magic, sometimes);
			//pre_mob_gen_flyer( hard, no_atk, 6, normal_speed, 	MOB_WANDER);
			pic_super_slime();
			pre_mob_generic( normal, no_atk, weak, slow_speed);
			pic_snake();
			pre_mob_generic( weak, no_atk, weak, normal_speed);
			pic_wizard_dark();// boss - death by arrow only - 2 arrow hits
			pre_mob_full( wizard, 20 , mob_weap_magic_weak, weak, normal_speed, MOB_WIZARD, death_by_arrow, 0);
			create=TRUE;	
		break;
		case 3:
			/*
			level 3 has likelike 1, mouse, bat
			*/
			pic_likelike();
			pre_mob_generic( strong, no_atk, normal, normal_speed);
			pic_mouse();
			pre_mob_generic( normal, mob_weap_boomerang, weak, normal_speed);
			pic_bat();
			pre_mob_gen_flyer( weak, no_atk, 2, 1, MOB_BAT);
			pic_golem();// death by bombs only
			pre_mob_full( generic, 16 , mob_weap_fireball3, normal, normal_speed, MOB_WANDER, death_by_bomb, sometimes);
			create=TRUE;	
		break;
		case 4:
			/*
			level 4 has ghoul 1/2, skeleton, bat
			*/
			pic_ghoul_2();
			pre_mob_generic( 20, mob_weap_magic, strong, slow_speed);
			pic_goul_1();
			pre_mob_generic( hard, no_atk, normal, normal_speed);
			pic_skeleton_light();
			pre_mob_generic( hard, mob_weap_wood_sword, normal, normal_speed);
			pic_bat();
			pre_mob_gen_flyer( normal, no_atk, 2, normal_speed, MOB_BAT);
			create=TRUE;	
		break;
		case 5:
			/*
			level 5 has likelike2, mummy1, knight 
			*/
			pic_likelike2_dark();
			pre_mob_generic( hard, no_atk, normal, normal_speed);
			pic_mummy();
			pre_mob_generic( hard, no_atk, strong, normal_speed);
			pic_knight_dark();
			pre_mob_full( generic, 20 , no_atk, normal, normal_speed, MOB_WANDER, shield_equipped, 0);
			create=TRUE;	
		break;				
		case 6:
			/*
			level 6 has  snail, wizard, knight
			*/
			pic_snail();
			pre_mob_generic( hard, mob_weap_fireball, normal, very_slow);
			pic_wizard_dark();
			pre_mob_full( wizard, hard , mob_weap_magic, strong, normal_speed, MOB_WIZARD, immune_magic, 0);
			pic_knight_dark();
			pre_mob_full( generic, 20 , no_atk, normal, normal_speed, MOB_WANDER, shield_equipped, sometimes);
			// this is for the super snail boss
			pic_snail();
			pre_mob_generic( 60, mob_weap_follow, hard, normal_speed);
			create=TRUE;	
		break;
		case 7:
			/*
			level 7 has  dragoon, reaper, mummy2, knight
			*/
			pic_dragoon_light();
			pre_mob_generic( 20, mob_weap_fireball, strong, normal_speed);
			pic_reaper();
			pre_mob_generic( ultra, no_atk, super, very_slow);
			pic_mummy2_light();
			pre_mob_generic( 40, no_atk, hard, normal_speed);
			pic_knight_white();
			pre_mob_full( generic, 20 , no_atk, strong, normal_speed, MOB_WANDER, shield_equipped, 0);
			create=TRUE;	
		break;
		case 8:
			/*
			level 8 has  eye, golem, skull head, knight
			*/
			pic_eye();
			pre_mob_generic( 40, mob_weap_fireball3, strong, fast_speed);
			pic_golem();
			pre_mob_generic( 50, no_atk, normal, slow_speed);
			pic_skull_head();
			pre_mob_generic( 60, mob_weap_arrow, strong, normal_speed);
			pic_knight_dark();
			pre_mob_full( generic, 24 , mob_weap_wood_sword, strong, normal_speed, MOB_WANDER, shield_equipped, 0);			
			create=TRUE;	
		break;
		case 9: 
			pic_fish();
			pre_mob_full(generic, 40 , mob_weap_ball, strong, normal_speed, MOB_WANDER, shield_equipped, 0);
			pic_gator();
			pre_mob_generic( 40, mob_weap_magic, strong, fast_speed);
			pic_stingray();
			pre_mob_gen_flyer( 50, no_atk, strong, normal_speed, MOB_WANDER);
			pic_toad();
			pre_mob_full( generic,60 , mob_weap_fireball, normal, normal_speed, MOB_WIZARD, death_by_fire, 0);
			create=TRUE;	
		break;
		case 10:// not used in simple quest
			/*
			castles have: all knights  
			*/
		//	pic_knight();
			pre_mob_full( generic, 40 , no_atk, strong, normal_speed, MOB_WANDER, shield_equipped, 0);
			pre_mob_full( generic, 40 , no_atk, strong, normal_speed, MOB_WANDER, shield_equipped, sometimes);
			pre_mob_full( generic, 40 , no_atk, strong, slow_speed, MOB_WANDER, shield_equipped, 0);
			pic_p_knight_1();
			pre_mob_full( generic, 60 , mob_weap_white_sword, hard, normal_speed, MOB_WANDER, shield_equipped, 0);
			pic_p_knight_2();
			pre_mob_full( generic, 60 , mob_weap_white_sword, hard, normal_speed, MOB_WANDER, shield_equipped, 0);
			pic_guard();
			pre_mob_full( generic, 60 , mob_weap_white_sword, hard, normal_speed, MOB_WANDER, shield_equipped, 0);
			//create=TRUE;	
		break;
		case 11:
			/*
					boss evil eye  - level 5
			*/
			center_eye_dark();
			pre_mob_boss( 80, 42, up, evil_eye,  40, no_atk, 0, hard, slow_speed, MOB_GHOST, nostun_immortal );
			circle_eye2_dark();
			pre_mob_boss( 0, 0, up, circle_eye,  20, no_atk, 0, normal, slow_speed, 0, 0 );
			pre_mob_boss( 0, 0, up, circle_eye,  20, no_atk, 0, normal, slow_speed, 0, 0 );
			pre_mob_boss( 0, 0, up, circle_eye,  20, no_atk, 0, normal, slow_speed, 0, 0 );
			pre_mob_boss( 0, 0, up, circle_eye,  20, no_atk, 0, normal, slow_speed, 0, 0 );
			pre_mob_boss( 0, 0, up, circle_eye,  20, no_atk, 0, normal, slow_speed, 0, 0 );
			pre_mob_boss( 0, 0, up, circle_eye,  20, no_atk, 0, normal, slow_speed, 0, 0 );
			pre_mob_boss( 0, 0, up, circle_eye,  20, no_atk, 0, normal, slow_speed, 0, 0 );
			create=TRUE;
			break;
		case 12:
			/*
					boss evil eye - level 8 boss
			*/
			center_eye_dark();
			pre_mob_boss( 80, 42, up, evil_eye,  120, mob_weap_follow, 0, super, slow_speed, MOB_GHOST, nostun_immortal );
			circle_eye2_dark();
			pre_mob_boss( 0, 0, up, circle_eye,  60, mob_weap_fireball, 0, hard, slow_speed, 0, 0 );
			pre_mob_boss( 0, 0, up, circle_eye,  60, mob_weap_fireball, 0, hard, slow_speed, 0, 0 );
			pre_mob_boss( 0, 0, up, circle_eye,  60, mob_weap_fireball, 0, hard, slow_speed, 0, 0 );
			pre_mob_boss( 0, 0, up, circle_eye,  60, mob_weap_fireball, 0, hard, slow_speed, 0, 0 );
			pre_mob_boss( 0, 0, up, circle_eye,  60, mob_weap_fireball, 0, hard, slow_speed, 0, 0 );
			pre_mob_boss( 0, 0, up, circle_eye,  60, mob_weap_fireball, 0, hard, slow_speed, 0, 0 );
			pre_mob_boss( 0, 0, up, circle_eye,  60, mob_weap_fireball, 0, hard, slow_speed, 0, 0 );
			create=TRUE;//skip=TRUE;
			break;
		case 13:// not used in simple quest
			/*
					boss spider  
			*/
			pic_spider_boss();
		//	pre_mob_boss( 80, 42, spider,  36, mob_weap_follow, 0, hard, normal_speed, MOB_WANDER, death_by_arrow );
		//	create=TRUE;
			break;
		case 14:
			/*
					pede- weak - level 4 boss
			*/
			pic_pede_head();
			pre_mob_boss( 2*16, 2*16, left, pede_head,  super, mob_weap_fireball, 0, hard, normal_speed, MOB_CONSTANT, nostun );
			pic_pede_body();
			pre_mob_boss( (3*16)-8, 32, left, pede_body,  super, no_atk, 0, normal, normal_speed, MOB_CONSTANT, nostun_immortal );
			pre_mob_boss( (3*16), 32, left, pede_body,  super, no_atk, 0, normal, normal_speed, MOB_CONSTANT, nostun_immortal );
			pre_mob_boss( (4*16)-8, 32, left, pede_body, super, no_atk, 0, normal, normal_speed, MOB_CONSTANT, nostun_immortal );
			pre_mob_boss( (4*16), 32, left, pede_body,  super, no_atk, 0, normal, normal_speed, MOB_CONSTANT, nostun_immortal );
			pre_mob_boss( (5*16)-8, 32, left, pede_body,  super, no_atk, 0, normal, normal_speed, MOB_CONSTANT, nostun_immortal );
			pre_mob_boss( (5*16), 32, left, pede_body,  super, no_atk, 0, normal, normal_speed, MOB_CONSTANT, nostun_immortal );
			pre_mob_boss( (6*16)-8, 32, left, pede_body,  super, no_atk, 0, normal, normal_speed, MOB_CONSTANT, nostun_immortal );
		//	pre_mob_boss( int x, int y, int type,  int hp, int atk, int defence, int dmg, int spd, int mv_type, int shld )
			create=TRUE;
			break;
		case 15:
			/*
					dual pede- strong - level 7 boss
			*/
			pic_pede_head();
			pre_mob_boss( 4*16, 2*16, left, pede_head,  60, mob_weap_fireball3, 0, hard, normal_speed, MOB_CONSTANT, nostun );
			
			pic_pede_body();
			pre_mob_boss( (5*16)-8, 32, left, pede_body,  60, no_atk, 0, normal, normal_speed, MOB_CONSTANT, nostun_immortal );
			pre_mob_boss( (5*16), 32, left, pede_body,  60, no_atk, 0, normal, normal_speed, MOB_CONSTANT, nostun_immortal );
			pre_mob_boss( (6*16)-8, 32, left, pede_body, 60, mob_weap_fireball3, 0, normal, normal_speed, MOB_CONSTANT, nostun_immortal );
			
			pic_pede_head();
			pre_mob_boss( 2*16, 4*16, left, pede_head,  60, mob_weap_fireball3, 0, hard, normal_speed, MOB_CONSTANT, nostun );
			pic_pede_body();
			pre_mob_boss( (3*16)-8, 64, left, pede_body,  60, no_atk, 0, normal, normal_speed, MOB_CONSTANT, nostun_immortal );
			pre_mob_boss( (3*16), 64, left, pede_body,  60, no_atk, 0, normal, normal_speed, MOB_CONSTANT, nostun_immortal );
			pre_mob_boss( (4*16)-8, 64, left, pede_body,  60, mob_weap_fireball3, 0, normal, normal_speed, MOB_CONSTANT, nostun_immortal );
		//	pre_mob_boss( int x, int y, int type,  int hp, int atk, int defence, int dmg, int spd, int mv_type, int shld )
			create=TRUE;
			break;
		case 16:
			pic_pede_head();
			pre_mob_boss( 4*16, 2*16, left, pede_head,  60, no_atk, 0, hard, normal_speed, MOB_CONSTANT, nostun );
			
			pic_pede_body();
			pre_mob_boss( (5*16)-8, 32, left, pede_body,  60, no_atk, 0, normal, normal_speed, MOB_CONSTANT, nostun_immortal );
			pre_mob_boss( (5*16), 32, left, pede_body,  60, no_atk, 0, normal, normal_speed, MOB_CONSTANT, nostun_immortal );
			pre_mob_boss( (6*16)-8, 32, left, pede_body,  60, mob_weap_fireball3, 0, normal, normal_speed, MOB_CONSTANT, nostun_immortal );
			
			pic_pede_head();
			pre_mob_boss( 2*16, 4*16, left, pede_head,  60, no_atk, 0, hard, normal_speed, MOB_CONSTANT, nostun );
			pic_pede_body();
			pre_mob_boss( (3*16)-8, 64, left, pede_body,  60, no_atk, 0, normal, normal_speed, MOB_CONSTANT, nostun_immortal );
			pre_mob_boss( (3*16), 64, left, pede_body,  60, no_atk, 0, normal, normal_speed, MOB_CONSTANT, nostun_immortal );
			pre_mob_boss( (4*16)-8, 64, left, pede_body,  60, mob_weap_fireball3, 0, normal, normal_speed, MOB_CONSTANT, nostun_immortal );
		//	pre_mob_boss( int x, int y, int type,  int hp, int atk, int defence, int dmg, int spd, int mv_type, int shld )
			create=TRUE;
		//	create=TRUE;
			break;			
		case 17:
			/*
			  	boss: 3 sages
			*/
			create=TRUE;
			pic_sage_1();
			pre_mob_full(flyer, 140 , mob_weap_fireball3, 20, fast_speed, MOB_WIZARD, nostun_immune_magic, 0);
			pic_sage_1();
			pre_mob_full(generic, 140 , mob_weap_magic, 20, normal_speed, MOB_WANDER, nostun_death_by_fire, 0);
			pic_sage_2();
			pre_mob_full(flyer, 100 , mob_weap_follow, 20, normal_speed, MOB_WIZARD, nostun_shield_immune_magic, 0);
		break;			
		case 18:// mountain mobs
			pic_butterfly();
			pre_mob_full( flyer, 4 , no_atk, 0, normal_speed, MOB_FLUTTER, immortal, 0);
			pic_octipus();
			pre_mob_full( generic, weak , mob_weap_ball, weak, normal_speed, MOB_WANDER, 0, sometimes);
			pic_red();
			pre_mob_generic( normal, mob_weap_arrow, weak, normal_speed);
			pic_spike();
			pre_mob_full( generic, weak , no_atk, weak, normal_speed, MOB_BAT, 0, sometimes);
			pic_sandmob();
			pre_mob_full( digger, normal , no_atk, normal, slow_speed, MOB_FOLLOW, 0, 0);			
			create=TRUE;
			break;			
		case 19:// forrest		
			pic_snake();
			pre_mob_generic( weak, no_atk, weak, normal_speed);
			pic_shroom();
			pre_mob_generic( normal, no_atk, weak, normal_speed);
			pic_bee();
			pre_mob_gen_flyer( weak, mob_weap_fireball, weak, normal_speed, MOB_WANDER);
			pic_ghost_white();
			pre_mob_gen_flyer( normal, no_atk, normal, slow_speed, MOB_GHOST);
			create=TRUE;
		break;
		case 20:// water area
			
			pic_ghost_white();
			pre_mob_gen_flyer( hard, mob_weap_magic, normal, normal_speed, MOB_GHOST);
			pic_stingray();
			pre_mob_gen_flyer( 20, no_atk, strong, normal_speed, MOB_WANDER);
			pic_mino();
			pre_mob_generic( 20, mob_weap_fireball3, strong, normal_speed);
			create=TRUE;
		break;	
		case 21:// for the shops in the towns
		//var_speed_npc(int loc, int x, int y, int msg_id, int msg_num, int speed, reducer)
		var_speed_npc(0, 8*16, 5*16, 1, 15, 0, left,0);
		pic_lady_2();
		var_speed_npc(1, 8*16, 5*16, 1, 15, 0, left,0);
		pic_old_lady();
		var_speed_npc(2, 8*16, 5*16, 1, 15, 0, left,0);
		pic_guy_3();
		var_speed_npc(3, 8*16, 5*16, 1, 15, 0, left,0);
		pic_guy_1();
		
		create=TRUE;
		break;
		case 22:
			zelda_qm(5*16, 3*16, 11, 10, down);
			pic_hime_zelda();
			create=TRUE;
		break;																													
		default:
			create=FALSE;
		break;
	}// end switch
	if (create) {fill_the_rest();save_mob_stats(i);if (!skip){save_mob_set(i);}}
	
}// end mob list create