// C Source File
// Created 2/2/2013; 11:23:50 PM

#include <tigcclib.h>
#include "defines.h"
#include "unique.h"
#include "routines.h"
static int proj_list[max_projectiles_size][max_projectiles_stats];



void proj_list_stats(int i)
{
// note the proj_xxxx defines have an offset of 20, so if you dont fix it, then it will always give you
// out of bounds errors.  this is so things will work right in zelda, b/c both the projectile list and
// the item list are combined in zelda. it adds to the confusion and complication, but it allows a mob
// to use both items and projectiles and it makes things easier for me, b/c i dont have to recode everything
// to figure out whether a mob is using an item or a projectile, instead i just call the get_item_info() and it
// will send back the info and it wont matter if it is a projectile or an item.

	switch (i)
	{
		case 0:// sword
			proj_list[i][proj_pic_id-20]=SWORD3;
			proj_list[i][proj_damage-20]=4;
			proj_list[i][proj_H-20]=14;
			proj_list[i][proj_W-20]=6;
		break;
		case 1:// boomerang
			proj_list[i][proj_pic_id-20]=1;
			proj_list[i][proj_damage-20]=4;
			proj_list[i][proj_H-20]=8;
			proj_list[i][proj_W-20]=12;
			proj_list[i][proj_type-20]=arrow_foe_rotate;
		break;		
		case 2:// arrow for creature
			proj_list[i][proj_pic_id-20]=5;
			proj_list[i][proj_damage-20]=8;
			proj_list[i][proj_H-20]=12;
			proj_list[i][proj_W-20]=4;
		break;
		case 3:// baLL for octi creature
			proj_list[i][proj_pic_id-20]=41;
			proj_list[i][proj_damage-20]=4;
			proj_list[i][proj_H-20]=8;
			proj_list[i][proj_W-20]=8;
			proj_list[i][proj_type-20]=arrow_foe_rotate;
		break;
		case 4:// powerful sword
			proj_list[i][proj_pic_id-20]=SWORD3;
			proj_list[i][proj_damage-20]=8;
			proj_list[i][proj_H-20]=14;
			proj_list[i][proj_W-20]=6;
		break;	
		case 5:// fireball
			proj_list[i][proj_pic_id-20]=64;
			proj_list[i][proj_damage-20]=8;
			proj_list[i][proj_H-20]=8;
			proj_list[i][proj_W-20]=8;
			proj_list[i][proj_type-20]=arrow_foe_rotate;
		break;		
		case 6:// magic
			proj_list[i][proj_pic_id-20]=65;
			proj_list[i][proj_damage-20]=8;
			proj_list[i][proj_H-20]=16;
			proj_list[i][proj_W-20]=16;
			proj_list[i][proj_type-20]=arrow_foe;
		break;
		case 7:// fireball x3
			proj_list[i][proj_pic_id-20]=64;
			proj_list[i][proj_damage-20]=8;
			proj_list[i][proj_H-20]=8;
			proj_list[i][proj_W-20]=8;
			proj_list[i][proj_type-20]=arrow_foe_multi_3;
		break;	
		case 8:// fireball x5
			proj_list[i][proj_pic_id-20]=64;
			proj_list[i][proj_damage-20]=8;
			proj_list[i][proj_H-20]=8;
			proj_list[i][proj_W-20]=8;
			proj_list[i][proj_type-20]=arrow_foe_multi_5;
		break;
		case 9:// fireball that follows link
			proj_list[i][proj_pic_id-20]=64;
			proj_list[i][proj_damage-20]=8;
			proj_list[i][proj_H-20]=8;
			proj_list[i][proj_W-20]=8;
			proj_list[i][proj_type-20]=arrow_foe_rotate_follow;
		break;	
		case 10:// fireball that shoots in a random diagnal direction
			proj_list[i][proj_pic_id-20]=64;
			proj_list[i][proj_damage-20]=8;
			proj_list[i][proj_H-20]=8;
			proj_list[i][proj_W-20]=8;
			proj_list[i][proj_type-20]=arrow_foe_diagnal;
		break;
		case 11:// weak magic - for level 3
			proj_list[i][proj_pic_id-20]=65;
			proj_list[i][proj_damage-20]=4;
			proj_list[i][proj_H-20]=16;
			proj_list[i][proj_W-20]=16;
			proj_list[i][proj_type-20]=arrow_foe;
		break;																	
	}// end switch	

}// end item list stats

void proj_setup()
{
	int i=0, k=0;
	while (i<max_projectiles_size){
		while (k<max_projectiles_stats){proj_list[i][k]=0;k++;}
		proj_list[i][proj_id-20]=i+projectile_offset;
		proj_list[i][proj_type-20]=arrow_foe;
		proj_list_stats(i);
		k=0;i++;
		
		}//end while
		
		
}// end item setup





//===================================================================================================================



void save_projectiles(int i)
{
char mapa[10],sav2[20];
	
		proj_setup();
		FolderCur(SYMSTR("items"),TRUE);	
						sprintf(mapa,"zprj%i",i);
		sprintf(sav2,"items\\zprj%i",i);
		HSym sym = SymFind (SYMSTR (mapa));	
    TRY
    if (sym.folder){cmd_unarchiv(SYMSTR(mapa));}// unarchive the save
    ONERR
    ENDTRY 
		
		FILE *f = NULL;
	TRY
		    
    short int fileio = TRUE;
			
	//	sprintf(mapa,"zitm%i",i);
		    if ((f = fopen(mapa,"wb")) == NULL) {// write into temp - use the file saving routine for the
    // saving of the real file.  for everything else, use the temp file
        fileio = FALSE;
    } else {
        // write inv data to the file
       

    		    if (fwrite(proj_list,sizeof(proj_list),1,f) != 1) {fileio = FALSE;}

	        fputc(0,f);
	        fputs("ZLD",f);
	        fputc(0,f);
	        fputc(OTH_TAG,f);
	
	        // close the file
	        fclose(f);       
       }// end else
       if (fileio){cmd_archive(SYMSTR(sav2));}
    ONERR
    ENDTRY
    
 }// end save mob stats