// C Source File
// Created 11/19/2013; 5:59:37 PM

#include <tigcclib.h>

#include "new_mobs.h"

unsigned short mob_pic_light_any[mob_gfx_list_size][16];
unsigned short mob_pic_dark_any[mob_gfx_list_size][16];
unsigned short mob_pic_mask_any[mob_gfx_list_size][16];
int loc_in_pic_arr=0,mob_location=0;
extern int num_of_sprites, num_of_walk_sprites, creature_width, creature_height,creature_animation_speed;
/* ===================================================================================================================

		this area will be used to create individual routines for each mob for their gfx.  these routines will be called
		to create new gfx files - just like the mob stats.  you will pass in the location where you want the mob pics 
		to be stored in the array.  the routines should have out of bounds error prevention in them.  meaning that if
		you try to pass in a section where it writes to the 3rd to last row in the main array, but it has 4 sprites with
		it, then it should return without adding the mob gfx to the gfx file, so if your mob does not show up in the 
		external gfx file, then it means that it went out of bounds. 
		
		these routines make it an easier and more scalable way to do things.  also, before you assign mobs to a list,
		be sure to call clr_mob_arrs() to clear out the arrays to prevent garbage if an area is called in the game.
		instead, it should display a blank box for the mob if it did not load right.  remember that the arrays start
		at 0 and go to mob_gfx_list_size-1.  so if you want the mob to have the first spot, then use zero. eejo dis.
up down left right

10 mobs per set

====================================================================================================================*/

void clr_mob_arrs()
{// clear out the mob arrays.
	int i=0,k=0;
		while (i<mob_gfx_list_size)
	{
		while (k<16)
		{
				mob_pic_light_any[i][k]=0;
				mob_pic_dark_any[i][k]=0;
				mob_pic_mask_any[i][k]=0;
			k++;
		}// end while k
		k=0;i++;
	}// end while i
}// end clr mob arrs.



//===================================================================================================================


void pic_guard()
{
	#undef gfx_size
	#define gfx_size 8
	
	num_of_sprites=gfx_size; num_of_walk_sprites=2;
	creature_animation_speed=5;
	creature_height=14;

	creature_width=14;		
	
		if ((loc_in_pic_arr+gfx_size)>mob_gfx_list_size){return;}// dont write if the stated area goes out of bounds
	static unsigned short tmp_l[gfx_size][16]={// for the light
	
	// up
	
  {0x03c0,0x07a0,0x09d8,0x1cdc,0x3c1e,0x3c1e,0x7c1e,0xfddf,0xbe3f,0xbbed,0x7bfd,0x3bfe,0x39fe,0x6c7e,0x77fe,0x3ffc},
 	{0x03c0,0x05e0,0x1b90,0x3b38,0x783c,0x783c,0x783e,0xfbbf,0xfc7d,0xb7dd,0xbfde,0x7fdc,0x7f9c,0x7e36,0x7fee,0x3ffc},
 	
	// down

	{0x700c,0x7ffc,0x3ddc,0x1ea8,0x7be8,0xf3ee,0xd1cf,0x908b,0xf089,0x9c9f,0x9ff9,0xf9ff,0xec37,0xffff,0xffff,0x7ffe},
 	{0x300e,0x3ffe,0x3bbc,0x1578,0x17de,0x77cf,0xf38b,0xd109,0x910f,0xf939,0x9ff9,0xff9f,0xec37,0xffff,0xffff,0x7ffe}, 	
	
	// left
	
	{0x007e,0x0ffe,0x1fdc,0x36f8,0x2ef0,0x3c10,0x3838,0x23f8,0x27f8,0x663c,0x5e3c,0x7dfe,0x3c7e,0x3ffe,0x7ffe,0x7ff8},
	{0x0000,0x00fc,0x1ffc,0x3fb8,0x6df0,0x5de0,0x7820,0x7070,0x47f0,0x4fff,0xfc7f,0xfc7f,0xfbff,0x78ff,0xfff8,0xfff0},	
 
	// right
	
	{0x7e00,0x7ff0,0x3bf8,0x1f6c,0x0f74,0x083c,0x1c1c,0x1fc4,0x1fe4,0x3c66,0x3c7a,0x7fbe,0x7e3c,0x7ffc,0x7ffe,0x1ffe},
  {0x0000,0x3f00,0x3ff8,0x1dfc,0x0fb6,0x07ba,0x041e,0x0e0e,0x0fe2,0xfff2,0xfe3f,0xfe3f,0xffdf,0xff1e,0x1fff,0x0fff}
	
	};// end light
	
	static unsigned short tmp_d[gfx_size][16]={// for the dark
	// up

	{0x03c0,0x0460,0x0e38,0x1f34,0x37f2,0x27f2,0x67fa,0xafff,0xfff5,0xe5d7,0x6407,0x2406,0x2606,0x7386,0x780e,0x3ffc},
  {0x03c0,0x0620,0x1c70,0x2cf8,0x4fec,0x4fe4,0x5fe6,0xfff5,0xafff,0xeba7,0xe026,0x6024,0x6064,0x61ce,0x701e,0x3ffc},

	// down

	{0x700c,0x4ff4,0x2634,0x1778,0x7ff8,0x9ebe,0xbff9,0xfffd,0xffff,0xffff,0xffff,0xfe3f,0x9ff9,0x8ff1,0x89f1,0x7ffe},	
	{0x300e,0x2ff2,0x2c64,0x1ee8,0x1ffe,0x7d79,0x9ffd,0xbfff,0xffff,0xffff,0xffff,0xfc7f,0x9ff9,0x8ff1,0x8f91,0x7ffe},
	
	// left

	{0x007e,0x0f82,0x10bc,0x2f88,0x3ff0,0x37f0,0x3fe8,0x3fc8,0x3c48,0x7de4,0x7fe4,0x67f2,0x27f2,0x3ffa,0x703e,0x7ff8},	
	{0x0000,0x00fc,0x1f04,0x2178,0x5f10,0x7fe0,0x6fe0,0x7fd0,0x7f90,0x788f,0xfbc1,0xcfe1,0xcff1,0x7fdf,0x8f18,0xfff0},
	
	// right
	
	{0x7e00,0x41f0,0x3d08,0x11f4,0x0ffc,0x0fec,0x17fc,0x13fc,0x123c,0x27be,0x27fe,0x4fe6,0x4fe4,0x5ffc,0x7c0e,0x1ffe},
  {0x0000,0x3f00,0x20f8,0x1e84,0x08fa,0x07fe,0x07f6,0x0bfe,0x09fe,0xf11e,0x83df,0x87f3,0x8ff3,0xfbfe,0x18f1,0x0fff} 
 
 
	
	};// end dark	
	
	static unsigned short tmp_m[gfx_size][16]={// for the mask
	// up
	{~0x03c0,~0x07e0,~0x0ff8,~0x1ffc,~0x3ffe,~0x3ffe,~0x7ffe,~0xffff,~0xffff,~0xffff,~0x7fff,~0x3ffe,~0x3ffe,~0x7ffe,~0x7ffe,~0x3ffc},
  {~0x03c0,~0x07e0,~0x1ff0,~0x3ff8,~0x7ffc,~0x7ffc,~0x7ffe,~0xffff,~0xffff,~0xffff,~0xfffe,~0x7ffc,~0x7ffc,~0x7ffe,~0x7ffe,~0x3ffc},
 
 
	// down
	{~0x700c,~0x7ffc,~0x3ffc,~0x1ff8,~0x7ff8,~0xfffe,~0xffff,~0xffff,~0xffff,~0xffff,~0xffff,~0xffff,~0xffff,~0xffff,~0xffff,~0x7ffe},
  {~0x300e,~0x3ffe,~0x3ffc,~0x1ff8,~0x1ffe,~0x7fff,~0xffff,~0xffff,~0xffff,~0xffff,~0xffff,~0xffff,~0xffff,~0xffff,~0xffff,~0x7ffe}, 
	
	
	// left
	{~0x007e,~0x0ffe,~0x1ffc,~0x3ff8,~0x3ff0,~0x3ff0,~0x3ff8,~0x3ff8,~0x3ff8,~0x7ffc,~0x7ffc,~0x7ffe,~0x3ffe,~0x3ffe,~0x7ffe,~0x7ff8},
 	{~0x0000,~0x00fc,~0x1ffc,~0x3ff8,~0x7ff0,~0x7fe0,~0x7fe0,~0x7ff0,~0x7ff0,~0x7fff,~0xffff,~0xffff,~0xffff,~0x7fff,~0xfff8,~0xfff0}, 
 	
	
	// right
	{~0x7e00,~0x7ff0,~0x3ff8,~0x1ffc,~0x0ffc,~0x0ffc,~0x1ffc,~0x1ffc,~0x1ffc,~0x3ffe,~0x3ffe,~0x7ffe,~0x7ffc,~0x7ffc,~0x7ffe,~0x1ffe},
	{~0x0000,~0x3f00,~0x3ff8,~0x1ffc,~0x0ffe,~0x07fe,~0x07fe,~0x0ffe,~0x0ffe,~0xfffe,~0xffff,~0xffff,~0xffff,~0xfffe,~0x1fff,~0x0fff}

	};	// end mask
	// now add those arrays to the main arrays.
	int k=0,p=0,oob=FALSE;
	while (p<gfx_size)
	{
		while (k<16)
		{
			if (loc_in_pic_arr<mob_gfx_list_size){// extra  protection to make sure it doesnt print out of bounds.
				mob_pic_light_any[loc_in_pic_arr][k]=tmp_l[p][k];
				mob_pic_dark_any[loc_in_pic_arr][k]=tmp_d[p][k];
				mob_pic_mask_any[loc_in_pic_arr][k]=tmp_m[p][k];
			}
			else{oob=TRUE;p=gfx_size;}//set this so i can throw an error
			k++;
		}// end while k
		k=0;p++;loc_in_pic_arr++;
	}// end while i
	if (oob){printf("guard out of bounds");}// throw an error that the mob is out of bounds so you know.

}// end guard

//===================================================================================================================


void pic_likelike()
{
//change <mob> and <dflt> and default
	#undef gfx_size
	#define gfx_size 2

	num_of_sprites=gfx_size; num_of_walk_sprites=1;
	creature_animation_speed=5;
	creature_height=14;

	creature_width=14;	
		if ((loc_in_pic_arr+gfx_size)>mob_gfx_list_size){return;}// dont write if the stated area goes out of bounds
	static unsigned short tmp_l[gfx_size][16]={// for the light

	// up light

 	{0x0000,0x0ff0,0x3ffc,0x5bda,0xbffd,0xbbdd,0x9ff9,0x8bd1,0xc813,0xfc3f,0xf7ef,0xbffd,0x8bd1,0xc813,0x7c3e,0x1ff8},
 
	// down light
 	{0x07e0,0x1ff8,0x2db4,0x3dbc,0x5ffa,0x4ff2,0x45a2,0x4422,0x6426,0x7e7e,0x7bde,0x5ffa,0x45a2,0x6426,0x3e7c,0x0ff0}	
	

	
	};// end light
	
	static unsigned short tmp_d[gfx_size][16]={// for the dark
	
	// up dark
 	{0x0000,0x0ff0,0x300c,0x67e6,0xc7e3,0xc7e3,0xe007,0xfc3f,0xffff,0xbffd,0x8ff1,0xc003,0xfc3f,0xffff,0x7ffe,0x1ff8},	
	
	// down dark
	{0x07e0,0x1818,0x33cc,0x23c4,0x6006,0x700e,0x7e7e,0x7ffe,0x7ffe,0x5ffa,0x47e2,0x6006,0x7e7e,0x7ffe,0x3ffc,0x0ff0}
 	

	
	};// end dark	
	
	static unsigned short tmp_m[gfx_size][16]={// for the mask
	
	// up mask
	
	{~0x0000,~0x0ff0,~0x3ffc,~0x7ffe,~0xffff,~0xffff,~0xffff,~0xffff,~0xffff,~0xffff,~0xffff,~0xffff,~0xffff,~0xffff,~0x7ffe,~0x1ff8},	
	
	// down mask
	
	{~0x07e0,~0x1ff8,~0x3ffc,~0x3ffc,~0x7ffe,~0x7ffe,~0x7ffe,~0x7ffe,~0x7ffe,~0x7ffe,~0x7ffe,~0x7ffe,~0x7ffe,~0x7ffe,~0x3ffc,~0x0ff0}	

	
	};	// end mask
	
	int k=0,p=0,oob=FALSE;
	while (p<gfx_size)
	{
		while (k<16)
		{
			if (loc_in_pic_arr<mob_gfx_list_size){
				mob_pic_light_any[loc_in_pic_arr][k]=tmp_l[p][k];
				mob_pic_dark_any[loc_in_pic_arr][k]=tmp_d[p][k];
				mob_pic_mask_any[loc_in_pic_arr][k]=tmp_m[p][k];
				}else{oob=TRUE;p=gfx_size;}
			k++;
		}// end while k
		k=0;p++;loc_in_pic_arr++;
	}// end while i
		if (oob){printf("likelike out of bounds");}

}// end likelike


//===================================================================================================================

void pic_golem()
{
//change <mob> and <dflt> and default
	#undef gfx_size
	#define gfx_size 8

	num_of_sprites=gfx_size; num_of_walk_sprites=2;
	
	creature_height=14;
	creature_animation_speed=5;
	creature_width=14;	

		if ((loc_in_pic_arr+gfx_size)>mob_gfx_list_size){return;}// dont write if the stated area goes out of bounds
	static unsigned short tmp_l[gfx_size][16]={// for the light

	// up light

	{0x0180,0x0760,0x0e10,0x0c10,0x3c1c,0x7e3e,0xc343,0xe187,0xd7e9,0xd819,0xe667,0xf9ef,0xef9f,0x79ff,0x1fff,0x1ffe},
	{0x0180,0x06e0,0x0870,0x0830,0x383c,0x7c7e,0xc2c3,0xe187,0x97eb,0x981b,0xe667,0xf79f,0xf9f7,0xff9e,0xfff8,0x7ff8}, 

	// down light
	{0x0180,0x0760,0x0c10,0x0d90,0x3fdc,0x7fde,0xcdb3,0xe247,0xd3cb,0xd999,0xe667,0xf9e7,0xef9f,0xf9f7,0x7fff,0x1ffe},
	{0x0180,0x06e0,0x0830,0x09b0,0x3bfc,0x7bfe,0xcdb3,0xe247,0xd3cb,0x999b,0xe667,0xe79f,0xf9f7,0xef9f,0xfffe,0x7ff8}, 	
	
	// left light
	{0x0780,0x0e40,0x1820,0x1c20,0x1c60,0x1df0,0x0b18,0x1238,0x1c68,0x10e8,0x0bc8,0x05f0,0x07f0,0x0de0,0x1ec0,0x1fc0},
	{0x0000,0x0780,0x0e40,0x1820,0x1c20,0x1c60,0x1df0,0x0b18,0x1238,0x1c68,0x10f4,0x0b3c,0x04fe,0x3b9e,0x71ce,0x3bfe},
	
	// right light
	{0x01e0,0x0270,0x0418,0x0438,0x0638,0x0fb8,0x18d0,0x1c48,0x1638,0x1708,0x13d0,0x0fa0,0x0fe0,0x07b0,0x0378,0x03f8},
	{0x0000,0x01e0,0x0270,0x0418,0x0438,0x0638,0x0fb8,0x18d0,0x1c48,0x1638,0x2f08,0x3cd0,0x7f20,0x79dc,0x738e,0x7fdc}, 

	
	};// end light
	
	static unsigned short tmp_d[gfx_size][16]={// for the dark
	
	// up dark
	{0x0180,0x06e0,0x09f0,0x0bf0,0x3bfc,0x45e2,0xbefd,0xffff,0xbfff,0xbfff,0xe7e7,0x9fed,0xaff9,0x7ffd,0x10f9,0x1ffe},
	{0x0180,0x0760,0x0f90,0x0fd0,0x3fdc,0x47a2,0xbf7d,0xffff,0xfffd,0xfffd,0xe7e7,0xb7f9,0x9ff5,0xbffe,0x9f08,0x7ff8}, 	
	
	// down dark
	{0x0180,0x06e0,0x0bf0,0x0bf0,0x3a7c,0x4bf2,0xbffd,0xffff,0xbfff,0xbfff,0xe7e7,0x9fe5,0xaff9,0x9ff5,0x70f9,0x1ffe},
	{0x0180,0x0760,0x0fd0,0x0fd0,0x3e5c,0x4fd2,0xbffd,0xffff,0xfffd,0xfffd,0xe7e7,0xa7f9,0x9ff5,0xaff9,0x9f0e,0x7ff8}, 	
	
	// left dark
	
	{0x0780,0x09c0,0x17e0,0x1fe0,0x17e0,0x1f90,0x0fe8,0x1ff8,0x1fd8,0x1fd8,0x0ff8,0x0730,0x0790,0x0f20,0x11c0,0x1fc0},
	{0x0000,0x0780,0x09c0,0x17e0,0x1fe0,0x17e0,0x1f90,0x0fe8,0x1ff8,0x1fd8,0x1fec,0x0ffc,0x07f2,0x3ffa,0x4ffa,0x37ee},
 	
	// right dark

	{0x01e0,0x0390,0x07e8,0x07f8,0x07e8,0x09f8,0x17f0,0x1ff8,0x1bf8,0x1bf8,0x1ff0,0x0ce0,0x09e0,0x04f0,0x0388,0x03f8},
	{0x0000,0x01e0,0x0390,0x07e8,0x07f8,0x07e8,0x09f8,0x17f0,0x1ff8,0x1bf8,0x37f8,0x3ff0,0x4fe0,0x5ffc,0x5ff2,0x77ec},
	
	};// end dark	
	
	static unsigned short tmp_m[gfx_size][16]={// for the mask
	
	// up mask

	{~0x0180,~0x07e0,~0x0ff0,~0x0ff0,~0x3ffc,~0x7ffe,~0xffff,~0xffff,~0xffff,~0xffff,~0xe7e7,~0xffef,~0xffff,~0x7fff,~0x1fff,~0x1ffe},	
	{~0x0180,~0x07e0,~0x0ff0,~0x0ff0,~0x3ffc,~0x7ffe,~0xffff,~0xffff,~0xffff,~0xffff,~0xe7e7,~0xf7ff,~0xfff7,~0xfffe,~0xfff8,~0x7ff8},
	
	// down mask
	{~0x0180,~0x07e0,~0x0ff0,~0x0ff0,~0x3ffc,~0x7ffe,~0xffff,~0xffff,~0xffff,~0xffff,~0xe7e7,~0xffe7,~0xefff,~0xfff7,~0x7fff,~0x1ffe},
 	{~0x0180,~0x07e0,~0x0ff0,~0x0ff0,~0x3ffc,~0x7ffe,~0xffff,~0xffff,~0xffff,~0xffff,~0xe7e7,~0xe7ff,~0xfff7,~0xefff,~0xfffe,~0x7ff8},
 	
	// left mask
	{~0x0780,~0x0fc0,~0x1fe0,~0x1fe0,~0x1fe0,~0x1ff0,~0x0ff8,~0x1ff8,~0x1ff8,~0x1ff8,~0x0ff8,~0x07f0,~0x07f0,~0x0fe0,~0x1fc0,~0x1fc0},	
	{~0x0000,~0x0780,~0x0fc0,~0x1fe0,~0x1fe0,~0x1fe0,~0x1ff0,~0x0ff8,~0x1ff8,~0x1ff8,~0x1ffc,~0x0ffc,~0x07fe,~0x3ffe,~0x7ffe,~0x3ffe},
 	
	// right mask
	{~0x01e0,~0x03f0,~0x07f8,~0x07f8,~0x07f8,~0x0ff8,~0x1ff0,~0x1ff8,~0x1ff8,~0x1ff8,~0x1ff0,~0x0fe0,~0x0fe0,~0x07f0,~0x03f8,~0x03f8},
	{~0x0000,~0x01e0,~0x03f0,~0x07f8,~0x07f8,~0x07f8,~0x0ff8,~0x1ff0,~0x1ff8,~0x1ff8,~0x3ff8,~0x3ff0,~0x7fe0,~0x7ffc,~0x7ffe,~0x7ffc},
	
	};	// end mask
	
	int k=0,p=0,oob=FALSE;
	while (p<gfx_size)
	{
		while (k<16)
		{
			if (loc_in_pic_arr<mob_gfx_list_size){
				mob_pic_light_any[loc_in_pic_arr][k]=tmp_l[p][k];
				mob_pic_dark_any[loc_in_pic_arr][k]=tmp_d[p][k];
				mob_pic_mask_any[loc_in_pic_arr][k]=tmp_m[p][k];
				}else{oob=TRUE;p=gfx_size;}
			k++;
		}// end while k
		k=0;p++;loc_in_pic_arr++;
	}// end while i
		if (oob){printf("golem out of bounds");}

}// end golem

//===================================================================================================================


void pic_mummy()
{

	#undef gfx_size
	#define gfx_size 2

	num_of_sprites=gfx_size; num_of_walk_sprites=1;
	
	creature_height=14;
	creature_animation_speed=5;
	creature_width=14;	

		if ((loc_in_pic_arr+gfx_size)>mob_gfx_list_size){return;}// dont write if the stated area goes out of bounds
	static unsigned short tmp_l[gfx_size][16]={// for the light

	// up light
	{0x0fe0,0x7390,0xf7e8,0x9fec,0xffee,0x9f0f,0xf3eb,0x967d,0xbbed,0x57ea,0x207e,0x7f82,0x43be,0xfec3,0xfc7f,0x007f},
  {0x07f0,0x09ce,0x17ef,0x37f9,0x77ff,0xf0f9,0xd7cf,0xbe69,0xb7dd,0x57ea,0x7e04,0x41fe,0x7dc2,0xc37f,0xfe3f,0xfe00} 
	
	};// end light
	
	static unsigned short tmp_d[gfx_size][16]={// for the dark
	
	// up dark
	{0x0fe0,0x7c70,0x9818,0xfb5c,0x9fda,0xf0f9,0x9c1d,0xf9f3,0xcc93,0x6f96,0x3ffe,0x407e,0x7fc2,0x86ff,0xfc41,0x007f},
  {0x07f0,0x0e3e,0x1819,0x3adf,0x5bf9,0x9f0f,0xb839,0xcf9f,0xc933,0x69f6,0x7ffc,0x7e02,0x43fe,0xff61,0x823f,0xfe00} 	
	
	};// end dark	
	
	static unsigned short tmp_m[gfx_size][16]={// for the mask
	
	// up mask
	{~0x0fe0,~0x7ff0,~0xfff8,~0xfffc,~0xfffe,~0xffff,~0xffff,~0xffff,~0xffff,~0x7ffe,~0x3ffe,~0x7ffe,~0x7ffe,~0xfeff,~0xfc7f,~0x007f},
 	{~0x07f0,~0x0ffe,~0x1fff,~0x3fff,~0x7fff,~0xffff,~0xffff,~0xffff,~0xffff,~0x7ffe,~0x7ffc,~0x7ffe,~0x7ffe,~0xff7f,~0xfe3f,~0xfe00}
	
	};	// end mask
	
	int k=0,p=0,oob=FALSE;
	while (p<gfx_size)
	{
		while (k<16)
		{
			if (loc_in_pic_arr<mob_gfx_list_size){
				mob_pic_light_any[loc_in_pic_arr][k]=tmp_l[p][k];
				mob_pic_dark_any[loc_in_pic_arr][k]=tmp_d[p][k];
				mob_pic_mask_any[loc_in_pic_arr][k]=tmp_m[p][k];
				}else{oob=TRUE;p=gfx_size;}
			k++;
		}// end while k
		k=0;p++;loc_in_pic_arr++;
	}// end while i
		if (oob){printf("mummy out of bounds");}

}// end mummy



//===================================================================================================================


void pic_sandmob()
{
//change <mob> and <dflt> and default

	#undef gfx_size
	#define gfx_size 4

	num_of_sprites=gfx_size; num_of_walk_sprites=1;
	creature_animation_speed=0;
	creature_height=14;

	creature_width=14;	
		if ((loc_in_pic_arr+gfx_size)>mob_gfx_list_size){return;}// dont write if the stated area goes out of bounds
	static unsigned short tmp_l[gfx_size][16]={// for the light

	// up light

	{0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0E70,0x1188,0x1248,0x4E72,0x4992,0x324C,0x0660,0x0180},	
	{0x0000,0x0000,0x0000,0x0000,0x0000,0x0660,0x0A50,0x3A5C,0x2BD4,0x2FF4,0x27E4,0x73CE,0x9BD9,0x1FF8,0x2FF4,0x07E0},	
	{0x0180,0x6246,0x524A,0x5BDA,0x4E72,0x4E72,0x6E76,0x3E7C,0x3FFC,0xFFFF,0x7FFE,0x7FFE,0xFE7F,0x3FFC,0x1FF8,0x0990},	
	{0x0C30,0x1248,0x324C,0x2BD4,0x2FF4,0x27E4,0x33CC,0x13C8,0x3BDC,0x7FFE,0x7FFE,0xFFFF,0x7E7E,0x7FFE,0x0FF0,0x0660}
	
	};// end light
	
	static unsigned short tmp_d[gfx_size][16]={// for the dark
	
	// up dark

	{0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0E70,0x1188,0x1248,0x4E72,0x4992,0x324C,0x0660,0x0180},	
	{0x0000,0x0000,0x0000,0x0000,0x0000,0x0660,0x0A50,0x3A5C,0x2BD4,0x2E74,0x27E4,0x63C6,0x93C9,0x1BD8,0x2FF4,0x07E0},	
	{0x0180,0x6246,0x524A,0x5BDA,0x4E72,0x4E72,0x4E72,0x2E74,0x3E7C,0xDFFB,0x5FFA,0x67E6,0xF81F,0x3FFC,0x1FF8,0x0990},	
	{0x0C30,0x1248,0x324C,0x2BD4,0x2E74,0x27E4,0x23C4,0x13C8,0x3BDC,0x5FFA,0x5FFA,0xE7E7,0x781E,0x7FFE,0x0FF0,0x0660}

	};// end dark	
	
	static unsigned short tmp_m[gfx_size][16]={// for the mask
	
	// up mask
	
	{~0x0000,~0x0000,~0x0000,~0x0000,~0x0000,~0x0000,~0x0000,~0x0000,~0x0E70,~0x1FF8,~0x3E7C,~0x7E7E,~0x799E,~0x33CC,~0x07E0,~0x0180},
	{~0x0000,~0x0000,~0x0000,~0x0000,~0x0000,~0x0660,~0x0E70,~0x3E7C,~0x3FFC,~0x3FFC,~0x3FFC,~0x7FFE,~0x9FF9,~0x1FF8,~0x2FF4,~0x07E0},
	{~0x0180,~0x63C6,~0x73CE,~0x7BDE,~0x7FFE,~0x7FFE,~0x7FFE,~0x3FFC,~0x3FFC,~0xFFFF,~0x7FFE,~0x7FFE,~0xFFFF,~0x3FFC,~0x1FF8,~0x0990},	
	{~0x0C30,~0x1E78,~0x3E7C,~0x3FFC,~0x3FFC,~0x3FFC,~0x3FFC,~0x1FF8,~0x3FFC,~0x7FFE,~0x7FFE,~0xFFFF,~0x7FFE,~0x7FFE,~0x0FF0,~0x0660}	
	
	};	// end mask
	
	int k=0,p=0,oob=FALSE;
	while (p<gfx_size)
	{
		while (k<16)
		{
			if (loc_in_pic_arr<mob_gfx_list_size){
				mob_pic_light_any[loc_in_pic_arr][k]=tmp_l[p][k];
				mob_pic_dark_any[loc_in_pic_arr][k]=tmp_d[p][k];
				mob_pic_mask_any[loc_in_pic_arr][k]=tmp_m[p][k];
				}else{oob=TRUE;p=gfx_size;}
			k++;
		}// end while k
		k=0;p++;loc_in_pic_arr++;
	}// end while i
		if (oob){printf("sandmob out of bounds");}

}// end sandmob



//===================================================================================================================


void pic_crab()
{

	#undef gfx_size
	#define gfx_size 2

	num_of_sprites=gfx_size; num_of_walk_sprites=1;
	
	creature_height=14;
	creature_animation_speed=2;
	creature_width=14;	

		if ((loc_in_pic_arr+gfx_size)>mob_gfx_list_size){return;}// dont write if the stated area goes out of bounds
	static unsigned short tmp_l[gfx_size][16]={// for the light

	// up light
	{0x0000,0x381C,0x4422,0x8C31,0x8A51,0x8A51,0x8A51,0xD66B,0x6FF6,0x3DBC,0x1DB8,0x3FFC,0x5BDA,0x9C39,0xBFFD,0xFFFF},
	{0x1C38,0x2244,0x4662,0x45A2,0x45A2,0x45A2,0x6BD6,0x37EC,0x3DBC,0x1DB8,0x1FF8,0x3BDC,0x5C3A,0x4FF2,0x5FFA,0x7FFE}
	
	};// end light
	
	static unsigned short tmp_d[gfx_size][16]={// for the dark
	
	// up dark

	{0x0000,0x381C,0x4422,0x8C31,0x8A51,0x8A51,0x8A51,0x9249,0x47E2,0x2DB4,0x1DB8,0x35AC,0x524A,0x9009,0xB81D,0xFFFF},	
	{0x1C38,0x2244,0x4662,0x45A2,0x45A2,0x45A2,0x4992,0x23C4,0x2DB4,0x1DB8,0x15A8,0x324C,0x500A,0x4812,0x5FFA,0x7FFE}
	
	};// end dark	
	
	static unsigned short tmp_m[gfx_size][16]={// for the mask
	
	// up mask
	{~0x0000,~0x381C,~0x7C3E,~0xFC3F,~0xFE7F,~0xFE7F,~0xFE7F,~0xFE7F,~0x7FFE,~0x3FFC,~0x1FF8,~0x3FFC,~0x7FFE,~0xFFFF,~0xFFFF,~0xFFFF},	
	{~0x1C38,~0x3E7C,~0x7E7E,~0x7FFE,~0x7FFE,~0x7FFE,~0x7FFE,~0x3FFC,~0x3FFC,~0x1FF8,~0x1FF8,~0x3FFC,~0x7FFE,~0x7FFE,~0x7FFE,~0x7FFE}
	
	};	// end mask
	
	int k=0,p=0,oob=FALSE;
	while (p<gfx_size)
	{
		while (k<16)
		{
			if (loc_in_pic_arr<mob_gfx_list_size){
				mob_pic_light_any[loc_in_pic_arr][k]=tmp_l[p][k];
				mob_pic_dark_any[loc_in_pic_arr][k]=tmp_d[p][k];
				mob_pic_mask_any[loc_in_pic_arr][k]=tmp_m[p][k];
				}else{oob=TRUE;p=gfx_size;}
			k++;
		}// end while k
		k=0;p++;loc_in_pic_arr++;
	}// end while i
		if (oob){printf("crab out of bounds");}

}// end crab

//===================================================================================================================



void pic_spike()
{
	#undef gfx_size
	#define gfx_size 4

	num_of_sprites=gfx_size; num_of_walk_sprites=0;
	
	creature_height=10;
	creature_animation_speed=3;
	creature_width=10;	
		if ((loc_in_pic_arr+gfx_size)>mob_gfx_list_size){return;}// dont write if the stated area goes out of bounds
	static unsigned short tmp_l[gfx_size][16]={// for the light

	// up light
	{0x0080,0x6143,0x514D,0x2FF2,0x1FEC,0x1B78,0x74B8,0xB4BE,0x74B1,0x1B7E,0x1FF8,0x2FE8,0x5FF4,0xB29A,0xC286,0x0100},
	{0x0100,0xC286,0xB28A,0x4FF4,0x37F8,0x1ED8,0x1D2E,0x7D2D,0x8D2E,0x7ED8,0x1FF8,0x17F4,0x2FFA,0x594D,0x6143,0x0080},	
	{0x0080,0x6143,0x594D,0x2FFA,0x17F4,0x1FF8,0x7ED8,0x8D2E,0x7D2D,0x1D2E,0x1ED8,0x37F8,0x4FF4,0xB28A,0xC286,0x0100},	
	{0x0100,0xC286,0xB29A,0x5FF4,0x2FE8,0x1FF8,0x1B7E,0x74B1,0xB4BE,0x74B8,0x1B78,0x1FEC,0x2FF2,0x514D,0x6143,0x0080},	
	
	};// end light
	
	static unsigned short tmp_d[gfx_size][16]={// for the dark
	
	// up dark
	
	{0x0080,0x6143,0x514D,0x2FF2,0x1FE4,0x1038,0x6498,0xA49E,0x6491,0x103E,0x1FF8,0x2FE8,0x4FE4,0xB29A,0xC286,0x0100},
	{0x0100,0xC286,0xB28A,0x4FF4,0x27F8,0x1C08,0x1926,0x7925,0x8926,0x7C08,0x1FF8,0x17F4,0x27F2,0x594D,0x6143,0x0080},	
	{0x0080,0x6143,0x594D,0x27F2,0x17F4,0x1FF8,0x7C08,0x8926,0x7925,0x1926,0x1C08,0x27F8,0x4FF4,0xB28A,0xC286,0x0100},	
	{0x0100,0xC286,0xB29A,0x4FE4,0x2FE8,0x1FF8,0x103E,0x6491,0xA49E,0x6498,0x1038,0x1FE4,0x2FF2,0x514D,0x6143,0x0080},	
	
	};// end dark	
	
	static unsigned short tmp_m[gfx_size][16]={// for the mask
	
	// up mask
	
	{~0x0080,~0x61C3,~0x71CF,~0x3FFE,~0x1FFC,~0x1FF8,~0x7FF8,~0xFFFE,~0x7FFF,~0x1FFE,~0x1FF8,~0x3FF8,~0x7FFC,~0xF39E,~0xC386,~0x0100},	
	{~0x0100,~0xC386,~0xF38E,~0x7FFC,~0x3FF8,~0x1FF8,~0x1FFE,~0x7FFF,~0xFFFE,~0x7FF8,~0x1FF8,~0x1FFC,~0x3FFE,~0x79CF,~0x61C3,~0x0080},	
	{~0x0080,~0x61C3,~0x79CF,~0x3FFE,~0x1FFC,~0x1FF8,~0x7FF8,~0xFFFE,~0x7FFF,~0x1FFE,~0x1FF8,~0x3FF8,~0x7FFC,~0xF38E,~0xC386,~0x0100},	
	{~0x0100,~0xC386,~0xF39E,~0x7FFC,~0x3FF8,~0x1FF8,~0x1FFE,~0x7FFF,~0xFFFE,~0x7FF8,~0x1FF8,~0x1FFC,~0x3FFE,~0x71CF,~0x61C3,~0x0080},	
	
	};	// end mask
	
	int k=0,p=0,oob=FALSE;
	while (p<gfx_size)
	{
		while (k<16)
		{
			if (loc_in_pic_arr<mob_gfx_list_size){
				mob_pic_light_any[loc_in_pic_arr][k]=tmp_l[p][k];
				mob_pic_dark_any[loc_in_pic_arr][k]=tmp_d[p][k];
				mob_pic_mask_any[loc_in_pic_arr][k]=tmp_m[p][k];
				}else{oob=TRUE;p=gfx_size;}
			k++;
		}// end while k
		k=0;p++;loc_in_pic_arr++;
	}// end while i
		if (oob){printf("spike out of bounds");}

}// end spike


//===================================================================================================================


void pic_octipus()
{

	#undef gfx_size
	#define gfx_size 8
	
	num_of_sprites=gfx_size; num_of_walk_sprites=2;
	
	creature_height=14;
	creature_animation_speed=4;
	creature_width=14;		

		if ((loc_in_pic_arr+gfx_size)>mob_gfx_list_size){return;}// dont write if the stated area goes out of bounds
	static unsigned short tmp_l[gfx_size][16]={// for the light

	// up light
	{0x0000,0x1FF8,0x1C38,0xCFF3,0xE667,0xFFFF,0x781E,0x3A5C,0x366C,0x342C,0x33CC,0x3E7C,0x7C3E,0xFE7F,0xEFF7,0x07E0},	
	{0x0000,0x1FF8,0x1C38,0x0FF0,0x0660,0x0FF0,0xF81F,0xFA5F,0xF66F,0x742E,0x33CC,0xFE7F,0xFC3F,0x7E7E,0x0FF0,0x07E0},	

	// down light
	{0x0000,0x07E0,0xEFF7,0xFE7F,0x7C3E,0x3E7C,0x33CC,0x342C,0x366C,0x3A5C,0x781E,0xFFFF,0xE667,0xCFF3,0x1C38,0x1FF8},	
	{0x0000,0x07E0,0x0FF0,0x7E7E,0xFC3F,0xFE7F,0x33CC,0x742E,0xF66F,0xFA5F,0xF81F,0x0FF0,0x0660,0x0FF0,0x1C38,0x1FF8},	

	// left light
	{0x0000,0x1CF0,0x1F1C,0x6ED6,0x75A3,0x5C23,0x5437,0x559F,0x54DF,0x5E5F,0x7F1E,0x7FFE,0x6CE6,0x0FFE,0x1FFF,0x1C07},	
	{0x03E0,0x0638,0xCDAC,0xEB46,0xB846,0xA86E,0xAB3E,0xA9BE,0xBCBE,0xFE3C,0xFFFC,0xD9CC,0x0FFC,0x0FF8,0x0770,0x0360},	

	// right light
	{0x0000,0x079C,0x1C7C,0x35BB,0x62D7,0x621D,0x7615,0x7CD5,0x7D95,0x7D3D,0x3C7F,0x3FFF,0x339B,0x3FF8,0x7FFC,0x701C},	
	{0x07C0,0x1C60,0x35B3,0x62D7,0x621D,0x7615,0x7CD5,0x7D95,0x7D3D,0x3C7F,0x3FFF,0x339B,0x3FF0,0x1FF0,0x0EE0,0x06C0},	

	};// end light
	
	static unsigned short tmp_d[gfx_size][16]={// for the dark
	
	// up dark
	{0x0000,0x1FF8,0x1008,0xCFF3,0xA425,0x9C39,0x500A,0x324C,0x2664,0x2424,0x2004,0x2004,0x500A,0x9009,0xE817,0x07E0},	
	{0x0000,0x1FF8,0x1008,0x0FF0,0x0420,0x0C30,0xF00F,0xB24D,0xA665,0x6426,0x2004,0xE007,0x9009,0x700E,0x0810,0x07E0},	

	// down dark
	{0x0000,0x07E0,0xE817,0x9009,0x500A,0x2004,0x2004,0x2424,0x2664,0x324C,0x500A,0x9C39,0xA425,0xCFF3,0x1008,0x1FF8},	
	{0x0000,0x07E0,0x0810,0x700E,0x9009,0xE007,0x2004,0x6426,0xA665,0xB24D,0xF00F,0x0C30,0x0420,0x0FF0,0x1008,0x1FF8},	

	// left dark
	{0x0000,0x1CF0,0x130C,0x6CC2,0x5581,0x5801,0x5001,0x5181,0x50C1,0x5041,0x5C02,0x5F3E,0x6CE6,0x09F2,0x13F9,0x1C07},	
	{0x03E0,0x0618,0xC984,0xAB02,0xB002,0xA002,0xA302,0xA182,0xA082,0xB804,0xBE3C,0xD94C,0x09CC,0x09C8,0x0550,0x0360},	

	// right dark
	{0x0000,0x079C,0x1864,0x219B,0x40D5,0x400D,0x4005,0x40C5,0x4185,0x4105,0x201D,0x3E7D,0x339B,0x27C8,0x4FE4,0x701C},		
	{0x07C0,0x1860,0x2193,0x40D5,0x400D,0x4005,0x40C5,0x4185,0x4105,0x201D,0x3C7D,0x329B,0x3390,0x1390,0x0AA0,0x06C0},		
	
	};// end dark	
	
	static unsigned short tmp_m[gfx_size][16]={// for the mask
	
	// up mask
	{~0x0000,~0x1FF8,~0x1FF8,~0xCFF3,~0xE7E7,~0xFFFF,~0x7FFE,~0x3FFC,~0x3FFC,~0x3FFC,~0x3FFC,~0x3FFC,~0x7FFE,~0xFFFF,~0xEFF7,~0x07E0},	
	{~0x0000,~0x1FF8,~0x1FF8,~0x0FF0,~0x07E0,~0x0FF0,~0xFFFF,~0xFFFF,~0xFFFF,~0x7FFE,~0x3FFC,~0xFFFF,~0xFFFF,~0x7FFE,~0x0FF0,~0x07E0},	

	// down mask
	{~0x0000,~0x07E0,~0xEFF7,~0xFFFF,~0x7FFE,~0x3FFC,~0x3FFC,~0x3FFC,~0x3FFC,~0x3FFC,~0x7FFE,~0xFFFF,~0xE7E7,~0xCFF3,~0x1FF8,~0x1FF8},
	{~0x0000,~0x07E0,~0x0FF0,~0x7FFE,~0xFFFF,~0xFFFF,~0x3FFC,~0x7FFE,~0xFFFF,~0xFFFF,~0xFFFF,~0x0FF0,~0x07E0,~0x0FF0,~0x1FF8,~0x1FF8},	

	// left mask
	{~0x0000,~0x1CF0,~0x1FFC,~0x6FFE,~0x77FF,~0x7FFF,~0x7FFF,~0x7FFF,~0x7FFF,~0x7FFF,~0x7FFE,~0x7FFE,~0x6FFE,~0x0FFE,~0x1FFF,~0x1C07},	
	{~0x03E0,~0x07F8,~0xCFFC,~0xEFFE,~0xFFFE,~0xFFFE,~0xFFFE,~0xFFFE,~0xFFFE,~0xFFFC,~0xFFFC,~0xDFFC,~0x0FFC,~0x0FF8,~0x0770,~0x0360},	

	// right mask
	{~0x0000,~0x079C,~0x1FFC,~0x3FFB,~0x7FF7,~0x7FFF,~0x7FFF,~0x7FFF,~0x7FFF,~0x7FFF,~0x3FFF,~0x3FFF,~0x3FFB,~0x3FF8,~0x7FFC,~0x701C},		
	{~0x07C0,~0x1FE0,~0x3FF3,~0x7FF7,~0x7FFF,~0x7FFF,~0x7FFF,~0x7FFF,~0x7FFF,~0x3FFF,~0x3FFF,~0x3FFB,~0x3FF0,~0x1FF0,~0x0EE0,~0x06C0},		
	
	};	// end mask
	
	int k=0,p=0,oob=FALSE;
	while (p<gfx_size)
	{
		while (k<16)
		{
			if (loc_in_pic_arr<mob_gfx_list_size){
				mob_pic_light_any[loc_in_pic_arr][k]=tmp_l[p][k];
				mob_pic_dark_any[loc_in_pic_arr][k]=tmp_d[p][k];
				mob_pic_mask_any[loc_in_pic_arr][k]=tmp_m[p][k];
				}else{oob=TRUE;p=gfx_size;}
			k++;
		}// end while k
		k=0;p++;loc_in_pic_arr++;
	}// end while i
		if (oob){printf("octipus out of bounds");}

}// end octipus


//===================================================================================================================


void pic_reaper()
{
	#undef gfx_size
	#define gfx_size 8

	num_of_sprites=gfx_size; num_of_walk_sprites=2;
	
	creature_height=14;
	creature_animation_speed=5;
	creature_width=14;	
	
		if ((loc_in_pic_arr+gfx_size)>mob_gfx_list_size){return;}// dont write if the stated area goes out of bounds
	static unsigned short tmp_l[gfx_size][16]={// for the light

	// up light
	{0x03e0,0x0590,0x0988,0x1108,0x1008,0x2814,0x2834,0x644a,0xa011,0x9021,0x8845,0xb78d,0x4c12,0x83e2,0x8001,0xffff},
	{0x07c0,0x09a0,0x1190,0x1088,0x1008,0x2814,0x2c14,0x5226,0x8805,0x8409,0xa211,0xb1ed,0x4832,0x47c1,0x8001,0xffff}, 

	// down light
	{0x03e0,0x0590,0x0b08,0x17c4,0x2844,0x37a2,0x3fd2,0x5ff5,0x9ff5,0x97dd,0xbcb1,0xbff9,0xbffa,0x67cd,0xc001,0xffff},
	{0x07c0,0x09a0,0x10d0,0x23e8,0x2214,0x45ec,0x4bfc,0xaffa,0xaff9,0xbbe9,0x8d3d,0x9ffd,0x5ffd,0xb3e6,0x8003,0xffff},	
	
	// left light
	{0x3fe0,0x3fd0,0x3e08,0x1604,0x3c1c,0x3e02,0x3f32,0x7d49,0x5dc7,0x53c2,0x7fc2,0x5fd6,0x3ffa,0x0301,0x0401,0x07ff},
	{0x0000,0x7fc0,0x7fa0,0x7c10,0x2c08,0x7838,0x7c04,0x7ee4,0xfa92,0xbb0e,0xa704,0xff04,0xbf2a,0x7ff1,0x1001,0x1fff}, 
 	
	
	// right light
	{0x07fc,0x0bfc,0x107c,0x2068,0x383c,0x407c,0x4cfc,0x92be,0xe3ba,0x43ca,0x43fe,0x6bfa,0x5ffc,0x80c0,0x8020,0xffe0},
	{0x0000,0x03fe,0x05fe,0x083e,0x1034,0x1c1e,0x203e,0x277e,0x495f,0x70dd,0x20e5,0x20ff,0x54fd,0x8ffe,0x8008,0xfff8} 	
	
	};// end light
	
	static unsigned short tmp_d[gfx_size][16]={// for the dark
	
	// up dark
	{0x03e0,0x0670,0x0e78,0x1ef8,0x1ff8,0x3ffc,0x3ffc,0x7ffe,0xffff,0xffff,0xffff,0xeff7,0x73ee,0xfc1e,0xffff,0xffff},
	{0x07c0,0x0e60,0x1e70,0x1f78,0x1ff8,0x3ffc,0x3ffc,0x7ffe,0xffff,0xffff,0xffff,0xeff7,0x77ce,0x783f,0xffff,0xffff}, 	
	
	// down dark
	{0x03e0,0x0670,0x0cf8,0x1ffc,0x3ffc,0x387e,0x34be,0x74df,0xf4df,0xf83f,0xdb7f,0xd877,0xdb76,0x7fff,0xffff,0xffff},
	{0x07c0,0x0e60,0x1f30,0x3ff8,0x3ffc,0x7e1c,0x7d2c,0xfb2e,0xfb2f,0xfc1f,0xfedb,0xee1b,0x6edb,0xfffe,0xffff,0xffff}, 
	
	
	// left dark
	{0x3fe0,0x2030,0x39f8,0x1dfc,0x27fc,0x2ffe,0x2ffe,0x4fff,0x63ff,0x6f3e,0x4d3e,0x693a,0x3fe6,0x03ff,0x07ff,0x07ff},
	{0x0000,0x7fc0,0x4060,0x73f0,0x3bf8,0x4ff8,0x5ffc,0x5ffc,0x9ffe,0xc7fe,0xdcfc,0x9cfc,0xd4f6,0x7fcf,0x1fff,0x1fff}, 	
	
	// right dark
	{0x07fc,0x0c04,0x1f9c,0x3fb8,0x3fe4,0x7ff4,0x7ff4,0xfff2,0xffc6,0x7cf6,0x7cb2,0x5c96,0x67fc,0xffc0,0xffe0,0xffe0},
	{0x0000,0x03fe,0x0602,0x0fce,0x1fdc,0x1ff2,0x3ffa,0x3ffa,0x7ff9,0x7fe3,0x3f3b,0x3f39,0x6f2b,0xf3fe,0xfff8,0xfff8} 
	
	};// end dark	
	
	static unsigned short tmp_m[gfx_size][16]={// for the mask
	
	// up mask
	{~0x03e0,~0x07f0,~0x0ff8,~0x1ff8,~0x1ff8,~0x3ffc,~0x3ffc,~0x7ffe,~0xffff,~0xffff,~0xffff,~0xffff,~0x7ffe,~0xfffe,~0xffff,~0xffff},
 	{~0x07c0,~0x0fe0,~0x1ff0,~0x1ff8,~0x1ff8,~0x3ffc,~0x3ffc,~0x7ffe,~0xffff,~0xffff,~0xffff,~0xffff,~0x7ffe,~0x7fff,~0xffff,~0xffff},	
	
	// down mask
	{~0x03e0,~0x07f0,~0x0ff8,~0x1ffc,~0x3ffc,~0x3ffe,~0x3ffe,~0x7fff,~0xffff,~0xffff,~0xffff,~0xffff,~0xfffe,~0x7fff,~0xffff,~0xffff},
	{~0x07c0,~0x0fe0,~0x1ff0,~0x3ff8,~0x3ffc,~0x7ffc,~0x7ffc,~0xfffe,~0xffff,~0xffff,~0xffff,~0xffff,~0x7fff,~0xfffe,~0xffff,~0xffff},
 	
	
	// left mask
	{~0x3fe0,~0x3ff0,~0x3ff8,~0x1ffc,~0x3ffc,~0x3ffe,~0x3ffe,~0x7fff,~0x7fff,~0x7ffe,~0x7ffe,~0x7ffe,~0x3ffe,~0x03ff,~0x07ff,~0x07ff},
	{~0x0000,~0x7fc0,~0x7fe0,~0x7ff0,~0x3ff8,~0x7ff8,~0x7ffc,~0x7ffc,~0xfffe,~0xfffe,~0xfffc,~0xfffc,~0xfffe,~0x7fff,~0x1fff,~0x1fff},	
	
	// right mask
	{~0x07fc,~0x0ffc,~0x1ffc,~0x3ff8,~0x3ffc,~0x7ffc,~0x7ffc,~0xfffe,~0xfffe,~0x7ffe,~0x7ffe,~0x7ffe,~0x7ffc,~0xffc0,~0xffe0,~0xffe0},
 	{~0x0000,~0x03fe,~0x07fe,~0x0ffe,~0x1ffc,~0x1ffe,~0x3ffe,~0x3ffe,~0x7fff,~0x7fff,~0x3fff,~0x3fff,~0x7fff,~0xfffe,~0xfff8,~0xfff8} 	
	
	};	// end mask
	
	int k=0,p=0,oob=FALSE;
	while (p<gfx_size)
	{
		while (k<16)
		{
			if (loc_in_pic_arr<mob_gfx_list_size){
				mob_pic_light_any[loc_in_pic_arr][k]=tmp_l[p][k];
				mob_pic_dark_any[loc_in_pic_arr][k]=tmp_d[p][k];
				mob_pic_mask_any[loc_in_pic_arr][k]=tmp_m[p][k];
				}else{oob=TRUE;p=gfx_size;}
			k++;
		}// end while k
		k=0;p++;loc_in_pic_arr++;
	}// end while i
		if (oob){printf("reaper out of bounds");}

}// end reaper



//===================================================================================================================


void pic_red()
{
	#undef gfx_size
	#define gfx_size 8

	num_of_sprites=gfx_size; num_of_walk_sprites=2;
	
	creature_height=14;
	creature_animation_speed=5;
	creature_width=14;	
	
		if ((loc_in_pic_arr+gfx_size)>mob_gfx_list_size){return;}// dont write if the stated area goes out of bounds
	static unsigned short tmp_l[gfx_size][16]={// for the light

	// up light
	{0xf3cf,0x8c31,0x47f2,0x2ffc,0x7ffc,0xfffe,0xdffd,0x9ffd,0x97f5,0xf006,0x380c,0x3ffc,0x3ffc,0x1fc4,0x3f82,0x00fe},
	{0xf3cf,0x8c31,0x4fe2,0x3ff4,0x3ffe,0x7fff,0xbffb,0xbff9,0xafe9,0x600f,0x301c,0x3ffc,0x3ffc,0x23f8,0x41fc,0x7f00},
 
	// down light
	{0xf3cf,0x8c31,0x542a,0x37ec,0x524a,0xf819,0xfffd,0xddbf,0x9bdf,0x77eb,0x7db9,0x73ee,0x7ffc,0x23f0,0x77f8,0x7fc0},	
	{0xf3cf,0x8c31,0x542a,0x37ec,0x524a,0x981f,0xbfff,0xfdbb,0xfbd9,0xd7ee,0x9dbe,0x77ce,0x3ffe,0x0fc4,0x1fee,0x03fe},
 
	
	// left light
	{0x0000,0x0fe0,0xf010,0xd668,0x8e1c,0x818e,0x83fe,0x77ff,0x7fff,0x5fbf,0x3747,0x1e07,0x1c4f,0x0ff9,0x1c79,0x1ffe},
	{0x0fe0,0xf010,0xd668,0x8e1c,0x818e,0x83be,0x77ff,0x7fff,0x5fef,0x3707,0x1e87,0x1c07,0x088f,0x07fc,0x0386,0x07fe}, 	
	
	// right light
	{0x0000,0x07f0,0x080f,0x166b,0x3871,0x7181,0x7fc1,0xffee,0xfffe,0xfdfa,0xe2ec,0xe078,0xf238,0x9ff0,0x9e38,0x7ff8},	
	{0x07f0,0x080f,0x166b,0x3871,0x7181,0x7dc1,0xffee,0xfffe,0xf7fa,0xe0ec,0xe178,0xe038,0xf110,0x3fe0,0x61c0,0x7fe0}
 	
	};// end light
	
	static unsigned short tmp_d[gfx_size][16]={// for the dark
	
	// up dark
	{0xf3cf,0xffff,0x7ffe,0x380c,0x57f4,0x9ffe,0xbfff,0xffff,0xffff,0xfffe,0x3ffc,0x3ffc,0x3ffc,0x1ffc,0x3ffe,0x00fe},
	{0xf3cf,0xffff,0x7ffe,0x301c,0x2fea,0x7ff9,0xfffd,0xffff,0xffff,0x7fff,0x3ffc,0x3ffc,0x3ffc,0x3ff8,0x7ffc,0x7f00}, 	
	
	// down dark
	{0xf3cf,0xffff,0x7ffe,0x3bdc,0x7ffe,0xffff,0x97ef,0xb66f,0xfdb9,0x781d,0x7e7f,0x7ffe,0x7c1c,0x3ff0,0x49f8,0x7fc0},
	{0xf3cf,0xffff,0x7ffe,0x3bdc,0x7ffe,0xffff,0xf7e9,0xf66d,0x9dbf,0xb81e,0xfe7e,0x7ffe,0x383e,0x0ffc,0x1f92,0x03fe},
 	
	
	// left dark
	{0x0000,0x0fe0,0xfff0,0xfff8,0xfdfc,0xfffa,0xfef6,0x7ccf,0x4dff,0x67cf,0x3cfd,0x1dfd,0x1fff,0x0fff,0x13e7,0x1ffe},
	{0x0fe0,0xfff0,0xfff8,0xfdfc,0xfffa,0xfef6,0x7ccf,0x4dff,0x679f,0x3ffd,0x19fd,0x1bff,0x0fff,0x07fc,0x027e,0x07fe},	
	
	// right dark
	{0x0000,0x07f0,0x0fff,0x1fff,0x3fbf,0x5fff,0x6f7f,0xf33e,0xffb2,0xf3e6,0xbf3c,0xbfb8,0xfff8,0xfff0,0xe7c8,0x7ff8},
	{0x07f0,0x0fff,0x1fff,0x3fbf,0x5fff,0x6f7f,0xf33e,0xffb2,0xf9e6,0xbffc,0xbf98,0xffd8,0xfff0,0x3fe0,0x7e40,0x7fe0}

	};// end dark	
	
	static unsigned short tmp_m[gfx_size][16]={// for the mask
	
	// up mask
	{~0xf3cf,~0xffff,~0x7ffe,~0x3ffc,~0x7ffc,~0xfffe,~0xffff,~0xffff,~0xffff,~0xfffe,~0x3ffc,~0x3ffc,~0x3ffc,~0x1ffc,~0x3ffe,~0x00fe},	
	{~0xf3cf,~0xffff,~0x7ffe,~0x3ffc,~0x3ffe,~0x7fff,~0xffff,~0xffff,~0xffff,~0x7fff,~0x3ffc,~0x3ffc,~0x3ffc,~0x3ff8,~0x7ffc,~0x7f00},
 
	// down mask
	{~0xf3cf,~0xffff,~0x7ffe,~0x3ffc,~0x7ffe,~0xffff,~0xffff,~0xffff,~0xffff,~0x7fff,~0x7fff,~0x7ffe,~0x7ffc,~0x3ff0,~0x7ff8,~0x7fc0},
	{~0xf3cf,~0xffff,~0x7ffe,~0x3ffc,~0x7ffe,~0xffff,~0xffff,~0xffff,~0xffff,~0xfffe,~0xfffe,~0x7ffe,~0x3ffe,~0x0ffc,~0x1ffe,~0x03fe}, 
	
	// left mask
	{~0x0000,~0x0fe0,~0xfff0,~0xfff8,~0xfffc,~0xfffe,~0xfffe,~0x7fff,~0x7fff,~0x7fff,~0x3fff,~0x1fff,~0x1fff,~0x0fff,~0x1fff,~0x1ffe},
	{~0x0fe0,~0xfff0,~0xfff8,~0xfffc,~0xfffe,~0xfffe,~0x7fff,~0x7fff,~0x7fff,~0x3fff,~0x1fff,~0x1fff,~0x0fff,~0x07fc,~0x03fe,~0x07fe},	
	
	// right mask
	{~0x0000,~0x07f0,~0x0fff,~0x1fff,~0x3fff,~0x7fff,~0x7fff,~0xfffe,~0xfffe,~0xfffe,~0xfffc,~0xfff8,~0xfff8,~0xfff0,~0xfff8,~0x7ff8},
	{~0x07f0,~0x0fff,~0x1fff,~0x3fff,~0x7fff,~0x7fff,~0xfffe,~0xfffe,~0xfffe,~0xfffc,~0xfff8,~0xfff8,~0xfff0,~0x3fe0,~0x7fc0,~0x7fe0}

	};	// end mask
	
	int k=0,p=0,oob=FALSE;
	while (p<gfx_size)
	{
		while (k<16)
		{
			if (loc_in_pic_arr<mob_gfx_list_size){
				mob_pic_light_any[loc_in_pic_arr][k]=tmp_l[p][k];
				mob_pic_dark_any[loc_in_pic_arr][k]=tmp_d[p][k];
				mob_pic_mask_any[loc_in_pic_arr][k]=tmp_m[p][k];
				}else{oob=TRUE;p=gfx_size;}
			k++;
		}// end while k
		k=0;p++;loc_in_pic_arr++;
	}// end while i
		if (oob){printf("red out of bounds");}

}// end red


//===================================================================================================================


//===================================================================================================================


//===================================================================================================================


//===================================================================================================================


//===================================================================================================================


//===================================================================================================================


//===================================================================================================================


//===================================================================================================================


//===================================================================================================================


//===================================================================================================================


//===================================================================================================================


//===================================================================================================================


//===================================================================================================================


//===================================================================================================================


//===================================================================================================================


//===================================================================================================================


//===================================================================================================================


//===================================================================================================================


//===================================================================================================================


//===================================================================================================================


//===================================================================================================================


//===================================================================================================================


//===================================================================================================================


//===================================================================================================================


//===================================================================================================================


//===================================================================================================================


//===================================================================================================================


//===================================================================================================================


//===================================================================================================================


//===================================================================================================================


//===================================================================================================================


//===================================================================================================================

