// C Source File
// Created 10/16/2014; 5:26:01 PM

#include <tigcclib.h>
#include "defines.h"
#include "new_mobs.h"
extern int loc_in_pic_arr, mob_location;
extern int mob_stat1[max_mobs][mob_num_of_stats];
void normal_npc(int loc, int x, int y, int msg_id, int msg_num)
{
	
	/*
			this is the normal moving towns person.  instead of making a ton of npc stats of the exact
			same thing, it was decided to just make a couple of set stats for it and then constantly
			call the same routine, while sending it different gfx pics.
	*/

	mob_stat1[mob_location][mob_sprites]=8;
	mob_stat1[mob_location][mob_walk_sprites]=2;
	mob_stat1[mob_location][mob_speed]=1; // moves 2 pixels at a time
	mob_stat1[mob_location][mob_stops]=sometimes;

	
	// dont modify below stats ===========================

	mob_stat1[mob_location][mob_hp]=-77;
	mob_stat1[mob_location][mob_dam]=0;
	
	mob_stat1[mob_location][mob_x]=x;
	mob_stat1[mob_location][mob_y]=y;
	
	mob_stat1[mob_location][mob_msg_id]=msg_id;
	mob_stat1[mob_location][mob_msg_num]=msg_num;

	mob_stat1[mob_location][mob_sprite_id]=loc_in_pic_arr;
	mob_stat1[mob_location][mob_current_sprite]=loc_in_pic_arr;
	mob_stat1[mob_location][mob_type]=towns_people;
	mob_stat1[mob_location][mob_move_type]=MOB_WANDER;
	mob_stat1[mob_location][mob_animation_speed]=5;
	mob_location++;
}// end mob sats1


void var_speed_npc(int loc, int x, int y, int msg_id, int msg_num, int speed, int dir, int reducer)
{
	
	/*0, 8*16, 5*16, 1, 15,0, left,0);
			same concept as the mob above, but walks slower
	*/

	mob_stat1[mob_location][mob_sprites]=8;
	mob_stat1[mob_location][mob_walk_sprites]=2;
	mob_stat1[mob_location][mob_speed]=speed;


	
	// dont modify below stats ===========================

	mob_stat1[mob_location][mob_hp]=8;
	mob_stat1[mob_location][mob_dam]=0;
	
	mob_stat1[mob_location][mob_x]=x;
	mob_stat1[mob_location][mob_y]=y;
	
	mob_stat1[mob_location][mob_msg_id]=msg_id;
	mob_stat1[mob_location][mob_msg_num]=msg_num;
	mob_stat1[mob_location][mob_dir]=dir;
	mob_stat1[mob_location][mob_sprite_id]=loc_in_pic_arr;
	mob_stat1[mob_location][mob_current_sprite]=loc_in_pic_arr;
	mob_stat1[mob_location][mob_type]=towns_people;
	mob_stat1[mob_location][mob_move_type]=MOB_WANDER;
	mob_stat1[mob_location][mob_animation_speed]=5;
	mob_stat1[mob_location][mob_stops]=reducer;
	mob_stat1[mob_location][mob_shield]=immortal;
	mob_location++;
}// end mob sats1

void zelda_qm(int x, int y, int talk, int death, int dir)
{
	
	/*0, 8*16, 5*16, 1, 15,0, left,0);
			same concept as the mob above, but walks slower
	*/

	mob_stat1[mob_location][mob_sprites]=8;
	mob_stat1[mob_location][mob_walk_sprites]=2;
	mob_stat1[mob_location][mob_speed]=0;


	
	// dont modify below stats ===========================

	mob_stat1[mob_location][mob_hp]=-1;
	mob_stat1[mob_location][mob_dam]=0;
	
	mob_stat1[mob_location][mob_x]=x;
	mob_stat1[mob_location][mob_y]=y;
	
	mob_stat1[mob_location][mob_msg_id]=talk;
  mob_stat1[mob_location][mob_sl_exec]=death;
	mob_stat1[mob_location][mob_dir]=dir;
	mob_stat1[mob_location][mob_sprite_id]=loc_in_pic_arr;
	mob_stat1[mob_location][mob_current_sprite]=loc_in_pic_arr;
	mob_stat1[mob_location][mob_type]=quest_master;
	mob_stat1[mob_location][mob_move_type]=MOB_WANDER;
	mob_stat1[mob_location][mob_animation_speed]=5;
	mob_stat1[mob_location][mob_stops]=0;
//	mob_stat1[mob_location][mob_shield]=0;
	mob_location++;
}// end mob sats1

void mob_butterfly2(int loc, int x, int y)
{

	mob_stat1[mob_location][mob_hp]=-77;// invincible
	mob_stat1[mob_location][mob_x]=x;
	mob_stat1[mob_location][mob_y]=y;
	mob_stat1[mob_location][mob_sprites]=2;
	mob_stat1[mob_location][mob_walk_sprites]=1;
	mob_stat1[mob_location][mob_sprite_id]=loc_in_pic_arr;
	mob_stat1[mob_location][mob_current_sprite]=loc_in_pic_arr;
	mob_stat1[mob_location][mob_type]=flyer;
	mob_stat1[mob_location][mob_animation_speed]=2;
	mob_stat1[mob_location][mob_move_type]=MOB_FLUTTER;
	mob_stat1[mob_location][mob_speed]=2;
	mob_location++;
}// end butterfly 

void gen_hop_mob(int loc, int x, int y, int type, int msg_id, int msg_num, int hp2 )
{
	// this is for the dog or chicken
	mob_stat1[mob_location][mob_hp]=hp2;
	mob_stat1[mob_location][mob_x]=x;
	mob_stat1[mob_location][mob_y]=y;
	mob_stat1[mob_location][mob_sprites]=4;
	mob_stat1[mob_location][mob_walk_sprites]=1;
	mob_stat1[mob_location][mob_sprite_id]=loc_in_pic_arr;
	mob_stat1[mob_location][mob_current_sprite]=loc_in_pic_arr;
	mob_stat1[mob_location][mob_type]=type;
	mob_stat1[mob_location][mob_speed]=2;
	mob_stat1[mob_location][mob_animation_speed]=4;
	mob_stat1[mob_location][mob_move_type]=MOB_HOP;
	mob_stat1[mob_location][mob_msg_id]=msg_id;
	mob_stat1[mob_location][mob_msg_num]=msg_num;
	mob_location++;
}

/*
void default(int loc, int x, int y, int gfx, int msg_id, int msg_num)
{
	
	/*
			<mob type>
	*/
/*
	mob_stat1[mob_location][mob_sprites]=8;
	mob_stat1[mob_location][mob_walk_sprites]=2;
	mob_stat1[mob_location][mob_speed]=2; // moves 2 pixels at a time
	

	
	// dont modify below stats ===========================

	mob_stat1[loc][mob_hp]=-77;
	mob_stat1[loc][mob_dam]=0;
	
	mob_stat1[loc][mob_x]=x;
	mob_stat1[loc][mob_y]=y;
	
	mob_stat1[loc][mob_msg_id]=msg_id;
	mob_stat1[loc][mob_msg_num]=msg_num;

	mob_stat1[loc][mob_sprite_id]=gfx;
	mob_stat1[loc][mob_type]=towns_people;
	mob_stat1[loc][mob_move_type]=MOB_WANDER;
	mob_stat1[loc][mob_animation_speed]=4;

	
}// end mob sats1
*/